#!/bin/sh
exec perl -w -x $0 ${1+"$@"}
    if 0;
#!perl


# mk_rules
# read descriptions of instructions and generate assem.y.pt4 file
# format of instruction description is
#     OPCODE    OPERAND OPERAND ...
# where each operand is one of REG, STK, NUM, SYM, CHAR, BUILTIN, or STR
# format of each part of assem.y.pt4 is
#       | KWOPCODE	OPERANDS...	{ emit(BC_OPCODE|OPERANDS); ...}


open(INSTRS,"<../bytecode/instrs.in") || die "Can't open instrs.in";
while (<INSTRS>)
{
    if (m/^\s*$/)
    {
	next;
    }
    (($opcode,$operands)=m/^(\S+)\s+(.*)$/) || die "Don't understand $_";
    @oplist=split(/\s+/,$operands);

    @ops=();
    @params=();
    $strparam="";

    $pos=2;
    foreach $op (@oplist)
    {
	if ($op eq "REG" || $op eq "STK" || $op eq "BUILTIN")
	{
	    push @ops,$pos;
	} elsif ($op eq "NUM" || $op eq "SYM" || $op eq "CHAR")
	{
	    push @params,$pos;
	} elsif ($op eq "STR")
	{
	    if ($strparam)
	    {
		die "Can't have more than one string parameter";
	    }
	    $strparam=$pos;
	} else
	{
	    die "Don't understand operand type $op";
	}
	$pos++;
    }

    print "\t| KW$opcode\t$operands\t{ emit(BC_$opcode";
    $opbits=8;
    foreach $op (@ops)
    {
	print "|(\$$op<<$opbits)";
	$opbits+=8;
    }
    print "); ";
    foreach $param (@params)
    {
	print "emit(\$$param); ";
    }
    if ($strparam)
    {
	print "emitstr(\$$strparam); ";
    }
    print "}\n";
}
