/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: header.in,v 1.1.1.1 1999/07/15 18:47:27 bardslea Exp $

	Symbolic names for the Lard bytecode encoding

	11 Jun 1999, AMULET Group
*/

#ifndef __BYTECODE__
#define __BYTECODE__
#define BC_ALLOC 200
#define BC_FREE 201
#define BC_PUSH 202
#define BC_POP 203
#define BC_POPFORGET 204
#define BC_LOAD 205
#define BC_STORE 206
#define BC_SETN 207
#define BC_SETSYM 208
#define BC_SETSYM_D 209
#define BC_SETC 210
#define BC_SETR 211
#define BC_ADD 212
#define BC_SUB 213
#define BC_RSB 214
#define BC_MUL 215
#define BC_DIV 216
#define BC_MOD 217
#define BC_NOT 218
#define BC_AND 219
#define BC_OR 220
#define BC_XOR 221
#define BC_SHL 222
#define BC_SHR 223
#define BC_INC 224
#define BC_DEC 225
#define BC_INC4 226
#define BC_DEC4 227
#define BC_CMPEQ 228
#define BC_CMPNEQ 229
#define BC_CMPLT 230
#define BC_CMPLTEQ 231
#define BC_CMPGT 232
#define BC_CMPGTEQ 233
#define BC_SETNNZ 234
#define BC_SETSYMNZ 235
#define BC_NOP 236
#define BC_BUILTIN 237
#define BC_END 238
#define BC_FORK 239
#define BC_DIE 240
#define BC_YIELD 241
#define BC_SETPRI 242
#define BC_SETMYPRI 243
#define BC_RUNCHECK 244
#define BC_LINE 245
#define BC_FILEREF 246
#define BC_STEPPOINT 247
#define BC_GETTIME 248
#define BI_stdin 100
#define BI_stdout 101
#define BI_stderr 102
#define BI_openin 103
#define BI_openout 104
#define BI_openinout 105
#define BI_close 106
#define BI_fprintint 107
#define BI_fprintstr 108
#define BI_fprintchar 109
#define BI_freadint 110
#define BI_freadstr 111
#define BI_freadchar 112
#define BI_teof 113
#define BI_beof 114
#define BI_setdefinpbase 115
#define BI_fputc 116
#define BI_fgetc 117
#define BI_fwrite 118
#define BI_fread 119
#define BI_fseek 120
#define BI_ftell 121
#define BI_flen 122
#define BI_ftrunc 123
#define BI_rand 124
#define BI_getversion 125
#define BI_regtime 126
#define BI_nexttime 127
#define BI_promote_waits 128
#define BI_export_var 129
#define BI_update_export_var 130
#define BI_tcl_cmd 131
#define BI_tcl_cmd_noerr 132
#define BI_tcl_cmd_int 133
#define BI_tcl_cmd_str 134
#define BI_fatal 135
#define BI_bitsdiff 136
#define BI_int2str 137
#define BI_int2hexstr 138
#define BI_create_sparray 139
#define BI_destroy_sparray 140
#define BI_index_sparray 141
#define BI_mpintop 142
#define BI_formatdata 143
#define BI_parsedata 144
#define BI_stringop 145
#define BI_i2s 146
#define BI_warning 147
#define BI_lardpos 148
#define BI_fsetunbuffered 149
#define BI_cosimulation_cmd 150
#define REG_PC 0
#define REG_T1 1
#define REG_T2 2
#define REG_T3 3
#define REG_T4 4
#define REG_T5 5
#define REG_T6 6
#define REG_T7 7
#define REG_T8 8
#define REG_CXP 9
#define REG_FPNUM 10
#define REG_TID 11
#define REG_TIME 12
#define NUM_REGS 13
#define STK_PS 0
#define STK_RAS 1
#define STK_CXS 2
#define STK_PTIME 3
#define NUM_STKS 4

#define MAGIC_NUMBER (0x42434F00+BCODE_VERSION)
#define WRONG_MAGIC (0x004F4342+(BCODE_VERSION<<24))

struct section_desc
{
  int sect_type;
  int start;
  int end;
  int private1;
  int private2;
};

#define HEADER_SECTTYPE MAGIC_NUMBER
#define CODE_SECTTYPE 1
#define RELOC_SECTTYPE 2
#define EXTERNSYM_SECTTYPE 3
#define INTERNSYM_SECTTYPE 4
#define OTHERFILES_SECTTYPE 5


#endif
