/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: escapify.c,v 1.1.1.1 1999/07/15 18:47:33 bardslea Exp $

	
	Escape strings for use in Tcl

	11 Jun 1999, AMULET Group
*/

#include <ctype.h>
#include <stdio.h>

#include <apasprintf.h>
#include <alloc.h>

#include "escapify.h"

char esccbuf[4];

char * escapify_chr ( char c )
{
  switch (c) {
    case '\n':
      return "\\n";
      break;
    case '\t':
      return "\\t";
      break;
    case '\r':
      return "\\r";
      break;
    case '\b':
      return "\\b";
      break;
    case '\f':
      return "\\f";
      break;
    case '\"':
      return "\\\"";
      break;
    case '\'':
      return "\\\'";
      break;
    case '\\':
      return "\\\\";
      break;
    default:
      if (iscntrl(c))
      {
        sprintf(esccbuf,"\\%03o",c);
      } else {
        esccbuf[0]=c;
        esccbuf[1]='\0';
      }
      return esccbuf;
  }
}


char * escapify_str ( char * s )
{
  char * p;
  char * q;

  p=palloc(1);
  p[0]='\0';
  q=s;
  while(*q) {
    apasprintf(&p,"%s",escapify_chr(*q));
    q++;
  }
  return p;
}
