/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: output.c,v 1.1.1.1 1999/07/15 18:47:34 bardslea Exp $


	Icode function printing

	11 Jun 1999, AMULET Group
*/

#include <stdio.h>

#include <alloc.h>
#include <error.h>

#include "parser_structs.h"
#include "output.h"
#include "codegen.h"
#include "main.h"

FILE * outf;

char * topdecls = NULL;
char * topcode = NULL;
char * stringcode = NULL;
char * stringinits = NULL;

void output_list ( struct list * list )
{
  if (list)
    {
      output_expr(list->expr);
      output_list(list->next);
    }
}


void output_expr ( struct expr * expr )
{
  if (expr->code)
    fputs(expr->code,outf);
  expr->code=NULL;
  if (expr->sort==fcall_es)
    output_list(expr->u.fc.args);
  if (expr->class)
    output_expr(expr->class);
}


void output_global_start ( void )
{
  fprintf(outf,"ENTRY_%s\n"
          "\tSETSYM PC INIT_%s\n\n",infilename,infilename);
}

void output_global_end ( void )
{
  if (stringcode)
  {
    fputs(stringcode,outf);
  }
  fputs(topdecls,outf);
  fprintf(outf,"\nINIT_%s\t\t\t\t# Main Program for file %s\n",
          infilename,infilename);
  if (stringcode)
  {
    fputs(stringinits,outf);
  }
  fputs(topcode,outf);
}
