/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: symtab.c,v 1.1.1.1 1999/07/15 18:47:35 bardslea Exp $


	More symbol table handling

	11 Jun 1999, AMULET Group
*/

#include <string.h>
#include <stddef.h>
#include <stdlib.h>

#include <alloc.h>
#include <simple.h>

#include "symtab.h"

struct symrec *sym_table = NULL;

struct symrec * putsym (char *sym_name)
{
  struct symrec * * ptr;
  int cmp;
  
  ptr=&sym_table;
  while (TRUE)
  {
    if (!(*ptr))
    {
      (*ptr)=palloc(sizeof(struct symrec));
      (*ptr)->name=palloc(strlen(sym_name)+1);
      strcpy((*ptr)->name,sym_name);
      (*ptr)->sort=isident;
      (*ptr)->left=NULL;
      (*ptr)->right=NULL;
      return (*ptr);
    }
    cmp=strcmp((*ptr)->name,sym_name);
    if (cmp==0)
    {
      return (*ptr);
    } else if (cmp<0)
    {
      ptr=&((*ptr)->right);
    } else
    {
      ptr=&((*ptr)->left);
    }
  }
}


void dump_symtable_i(FILE * f, struct symrec * p)
{
  if (p)
  {
    dump_symtable_i(f,p->left);
    fprintf(f,"%20s  %s\n",p->name,
	    p->sort==iskeyword?"keyword":"identifier");
    dump_symtable_i(f,p->right);
  }
}

void dump_symtable(FILE *f)
{
  dump_symtable_i(f,sym_table);
}





