/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: exec.c,v 1.3 2001/04/11 11:37:18 bardslea Exp $


	Execute bytecodes

	11 Jun 1999, AMULET Group
*/

#include "load_link.h"
#include "regs.h"
#include "heap.h"
#include "stacks.h"
#include "basic.h"
#include "builtin.h"
#include "debug.h"
#include "symbols.h"
#include "simple.h"
#include "../bytecode/bytecode.h"
#include "threads.h"
#include "profile.h"
#include "lierror.h"
#include "start.h"
#include "io.h"
#include "linenos.h"
#include "misc.h"
#include <string.h>

bool end_flag = FALSE;

bool exec (int max_instrs)
{
  int instr;
  int opcode;
  int op1;
  int op2;
  int op3;
  int n;

  if (!bci_ready)
  {
    li_fatal("No bcode file loaded\n");
    return FALSE;
  }
  end_flag=FALSE;
  for(n=0;(n!=max_instrs)&&(!end_flag);n++)
  {
    if (PC==codesz)
    {
      f_END();
      continue;
    };
    if (PC>codesz || PC<0)
    {
      li_fatal("PC Out of bounds\n");
      continue;
    }
    debug("%-30s:",printsym(PC));
    if (do_profile)
    {
      cprof[PC]++;
      instrs++;
    }
    instr=code[PC];
    opcode=instr&0xff;
    op1=(instr&0xff00)>>8;
    op2=(instr&0xff0000)>>16;
    op3=(instr&0xff000000)>>24;
    PC++;
    switch (opcode)
    {
#include "exec_body"
    default:
      li_fatal("Illegal instruction %d\n",opcode);
    }
    if (redo_input)
    {
      break;
    }
    if (steppoint_break)
    {
      break;
    }
  }
  return (!end_flag);
}
