/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: format.h,v 1.1.1.1 1999/07/15 18:47:41 bardslea Exp $

    <What this file does>

	11 Jun 1999, AMULET Group
*/
/*
	`format.h'
	printf-like format string handling (formatting/parsing)

	1 Apr 1999, Andrew Bardsley
*/

#ifndef FORMAT_HEADER
#define FORMAT_HEADER

/* make_format_array: make an array of void* from a string containing
	4 digit hex values and maybe some space separation */
void **make_format_array (int argCount, char *argStr);

/* lard_format_from_array: make a formatted string from the args in `args' */
char *lard_format_from_array (char *format, int argCount, void **args);

/* formatdata: format some raw data according to a LARD format string */
void formatdata (void);

/* parsedata: parse some raw data according to a LARD format string,
	this function will be called with a single ref/var pointing to
	the data and a data byte count */
void parsedata (void);

#endif
