/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: heap.c,v 1.2 2000/04/25 00:16:19 bardslea Exp $


	Heap memory management

	11 Jun 1999, AMULET Group
*/

#include <stdio.h>

#include <alloc.h>
#include <simple.h>

#include "regs.h"
#include "lierror.h"


void f_ALLOC ( int size_reg, int addr_reg )
{
  regs[addr_reg]=(int)palloc(regs[size_reg]);
}


void f_FREE ( int addr_reg )
{
  free((void *)regs[addr_reg]);
}


bool check_addr( int addr )
{
  if (addr&3)
  {
    li_fatal("Accessing an unaligned pointer\n");
    return FALSE;
  }
  if (!addr)
  {
    li_fatal("Accessing a null pointer\n");
    return FALSE;
  }
  return TRUE;
}


void f_LOAD ( int addr_reg, int data_reg )
{
  if (check_addr(regs[addr_reg]))
    regs[data_reg]=*((int *)regs[addr_reg]);
}

void f_STORE ( int addr_reg, int data_reg )
{
  if (check_addr(regs[addr_reg]))
    *((int *)regs[addr_reg])=regs[data_reg];
}


