#!/bin/sh
exec perl -w -x $0 ${1+"$@"}
    if 0;
#!perl

# Script to generate init.tcl, incorporating the library directory
# which is determined at compile time.

$li_lib_dir=$ARGV[0];
$bcode_stdlib_dir=$ARGV[1];

print "
\"

# This file is automatically generated from init.tcl.pl.  Do not edit.

# Note: this file is #included into main.c.  This means that it has
# to have quotes at start and end, and quotes in the body have to be
# escaped.  Also note that for changes to this file to take effect the
# C code must be recompiled.


set li_lib_dir \\\"$li_lib_dir\\\"
set bcode_stdlib_dir \\\"$bcode_stdlib_dir\\\"

if {[catch {set env(LI_LOAD_PATH)}]} {
    set li_load_path \$li_lib_dir
} else {
    set li_load_path [split \$env(LI_LOAD_PATH) :]
    lappend li_load_path \$li_lib_dir
}

set bcode_load_path \\\".\\\"
lappend bcode_load_path \$bcode_stdlib_dir

# Need to give -lstdlib first
set bcode_libraries \\\"\\\"

# LI_LOPTS to contain -L and -l library loading
# commands for li.
if {! [catch {set env(LI_OPTS)}]} {
    set split_opts [split \$env(LI_OPTS) \\\" \\\"]
    foreach opt \$split_opts {
    	if {[cequal \\\"-l\\\" [csubstr \$opt 0 2]]} {
			lappend bcode_libraries [csubstr \$opt 2 end]
    	}
    	if {[cequal \\\"-L\\\" [csubstr \$opt 0 2]]} {
			lappend bcode_load_path [csubstr \$opt 2 end]
    	}
    }
}

proc li_load {name} {
    global li_load_path
    
    foreach dir \$li_load_path {
	if {[file exists \\\"\$dir/\$name.tcl\\\"]} {
	    uplevel \\\\\#0 source \\\"\$dir/\$name.tcl\\\"
	    return
	}
    }
    error \\\"Can't find load file \$name.tcl\\\"
}

proc bci_load {name} {
	global bcode_load_path
	global bcode_libraries

	foreach lib \$bcode_libraries {
	    foreach dir \$bcode_load_path {
		if {[file exists \\\"\$dir/\$lib.bcode\\\"]} {
		    bci_load_unlinked \$dir/\$lib.bcode
		    break
		}
	    }
	}
	bci_load_internal \$name
}

li_load start

\"

";

