/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: lard_time.c,v 1.4 2002/10/24 12:24:41 janinl Exp $


	Simulation time

	11 Jun 1999, AMULET Group
*/

#include <stddef.h>

#include <alloc.h>

#include "threads.h"
#include "lierror.h"
#include "stacks.h"
#include "simple.h"

struct timelist
{
  int tid;
  int time;
  struct timelist * next;
};

struct timelist * tl = NULL;


void regtime ( void )
{
  int tid;
  int time;
  struct timelist * * a;
  struct timelist * new;

  tid=param_pop();
  time=param_pop();

  new=palloc(sizeof(struct timelist));
  new->tid=tid;
  new->time=time;

  if (!tl)
  {
    new->next=NULL;
    tl=new;
    return;
  }

  a=&tl;
  while ((*a) && ((*a)->time<time))
  {
    a=&((*a)->next);
  }

  new->next=(*a);
  (*a)=new;
}

static int current_time;

void nexttime ( void )
{
  bool perpetual = (bool) param_pop ();
  bool cosim = (bool) param_pop ();
 /* int time; */
  struct timelist * x;
  
  if (!tl)
  {
    param_push(perpetual ? current_time + 1 : -1);
    return;
  }

  if (cosim)
    current_time=current_time+1;
  else
    current_time=tl->time;

  while (tl && tl->time==current_time)
  {
    setpriority(tl->tid,PRI_RUN);
    x=tl;
    tl=tl->next;
    free(x);
  }

  param_push(current_time);
}
