/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: lierror.c,v 1.4 2000/12/04 16:42:57 bardslea Exp $


	Error message printing

	11 Jun 1999, AMULET Group
*/

#include <stdio.h>
#include <stdarg.h>

#include "stacks.h"
#include "exec.h"
#include "start.h"
#include "stringops.h"
#include "tcl_if.h"
#include "linenos.h"

#include <alloc.h>

char bci_error_msg[1024];

void li_veryfatal ( char * msg )
{
  fputs(msg,stderr);
  exit(1);
}


void li_fatal ( char *fmt, ...)
{
  va_list ap;

  va_start(ap,fmt);
  vsprintf(bci_error_msg,fmt,ap);
  va_end(ap);
  end_flag=TRUE;
  bci_ready=FALSE;
}

void fatal_builtin ( void )
{
  char * msg;
  struct crec * cr;
  char * pos = lardpos ();

  cr=(struct crec *)param_pop();
  msg=cr->str;
  if (!msg)
  {
    li_fatal("Uninitialised string passed to li_fatal\n");
    return;
  }
  li_fatal("%s %s",pos,msg);
}

void warning_builtin ( void )
{
  char * msg;
  struct crec * cr;

  cr=(struct crec *)param_pop();
  msg=cr->str;
  if (!msg)
  {
    li_fatal("Uninitialised string passed to warning\n");
    return;
  } else {
	char *tcl_cmd = (char *) palloc (strlen (msg) + 10);
  	sprintf(tcl_cmd,"msg {%s}",msg);
	tcl_cmd_noerr(tcl_cmd);
	free(tcl_cmd);
  }
}
