/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: linenos.c,v 1.3 2000/12/04 16:42:58 bardslea Exp $


	Line number handling

	11 Jun 1999, AMULET Group
*/


#include <stdio.h>

#include <alloc.h>
#include <simple.h>
#include <string.h>

#include "regs.h"
#include "tcl_if.h"
#include "stacks.h"
#include "stringops.h"

int current_linenum;
int current_fileref;
char *current_filename = NULL;

bool steppointreached=FALSE;
bool steppoint_break=FALSE;


void f_FILEREF ( int filesym, char * filename )
{
  char * p;

  p=palloc(40+strlen(filename));
  sprintf(p,"line_setfileref %d {%s}",PC+filesym-2,filename);
  if (current_filename) free (current_filename);
  current_filename = strdup (filename);
  tcl_cmd_noerr(p);
  free(p);
}


void f_LINE ( int filesym, int linenum )
{
  current_fileref=PC+filesym-2;
  current_linenum=linenum;
  if (steppointreached)
  {
    steppoint_break=TRUE;
    steppointreached=FALSE;
  }
}

void f_STEPPOINT ( void )
{
  steppointreached=TRUE;
}

char *lardpos (void)
{
	char *ret;

	if (! current_filename) ret = strdup ("");
	else {
		ret = (char *) palloc (strlen (current_filename) + 10);
		sprintf (ret, "%s:%i", current_filename, current_linenum);
	}
	return ret;
}

void lardpos_builtin (void)
{
	struct crec *ret = (struct crec *) palloc (sizeof (struct crec));
	ret->refcount = 0;
	
	ret->str = lardpos ();
	ret->refcount = 0;
	param_push ((int) ret); /* nasty, evil, non LP64 clean */
}
