/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: misc.c,v 1.1.1.1 1999/07/15 18:47:39 bardslea Exp $


	Miscellaneous number handling

	11 Jun 1999, AMULET Group
*/

#include <config.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include <alloc.h>

#include "stacks.h"
#include "lierror.h"
#include "regs.h"


int misc_allocs=0;

unsigned int seed=0x42424242;

/* Thanks to Oleg for the following: */
unsigned int my_random ( void )
{
  unsigned int i, bits[4];

  for(i=0;i<3;i++)
    bits[i] = (seed >> i) & 1;
  bits[3] = (seed >> 22) & 1;

  seed=seed>>1;

  if ((bits[3]^bits[2]^bits[1]^bits[0])==1)
    seed=seed|0x80000000;

  return seed;
}


void l_rand ( void )
{
  int max;
  int r;
  
  max=param_pop();
  if (max!=0)
    r=my_random()%max;
  else
    r=0;
  param_push(r);
}


void getversion ( void )

{
  param_push(BCODE_VERSION);
}


void bitsdiff ( void )
{
  int T;
  unsigned int * v1;
  unsigned int a;
  int i;
  int bd;
  
  T=param_pop();
  v1=palloc(T);
  for(i=0;i<T/4;i++) {
    v1[i]=param_pop();
  }
  bd=0;
  for(i=0;i<T/4;i++) {
    a=param_pop();
    a=a^v1[i];
    while (a) {
      if ((a&1)==1) {
        bd++;
      }
      a>>=1;
    }
  }
  param_push(bd);
}


