/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: stacks.h,v 1.1.1.1 1999/07/15 18:47:38 bardslea Exp $

 
	Machine stack handling

	11 Jun 1999, AMULET Group
*/

#ifndef __STACKS__
#define __STACKS__

#include "../bytecode/bytecode.h"

extern struct stack * stacks;

#define STK_CHUNK_SZ (1023)

struct stack_chunk
{
  struct stack_chunk * prev_chunk;
  int data[STK_CHUNK_SZ];
};

struct stack
{
  struct stack_chunk * top_chunk;
  int index;
};


void init_stacks ( struct stack * stacks );

void f_PUSH ( int stk_num, int data_reg );

void f_POP ( int stk_num, int data_reg );

void f_POPFORGET ( int stk_num, int popcountreg );

extern char * stacknames[NUM_STKS];


int param_pop(void);

void param_push(int n);


#endif
