/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: stringops.h,v 1.1.1.1 1999/07/15 18:47:40 bardslea Exp $


    Strings library builtins

	11 Jun 1999, AMULET Group
*/
#ifndef STRINGOPS_HEADER
#define STRINGOPS_HEADER

#include "simple.h"

/* strings library builtins */

struct crec {     /* type of a string control record */
  int refcount;
  char * str;
};

extern void free_if_zero ( struct crec * cr );
extern bool checkstrcr ( struct crec * cr, char * func );

/* stringop: despatch calls to the builtin `stringops' providing
	functions for string manipulation */
extern void stringop ( void );

void int2str ( void );
void int2hexstr ( void );

extern void l_c2s ( void );
extern void l_strindex ( void );
extern void l_strlen ( void );
extern void l_strcat ( void );
extern void l_strcmp ( void );
extern void l_substr ( void );
extern void l_strdchr ( void );
extern void l_strdstr ( void );

#endif
