/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: symbols.c,v 1.2 2000/04/25 00:16:22 bardslea Exp $


	Bcode symbol handling

	11 Jun 1999, AMULET Group
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

#include <alloc.h>
#include <lard_link.h>

#include "debug.h"
#include "profile.h"
#include "load_link.h"

#ifndef CLOCKS_PER_SEC
/* Assume microseconds */
#define CLOCKS_PER_SEC (1000000)
#endif

char buff[2048];

struct symtree * syms=NULL;

char * printsym ( int addr )
{
  char * s;
  struct symtree * p;
  int best;
  
  s="???";
  p=syms;
  best=-1;
  
  p = symtree_find_by_addr (p, addr);

  sprintf(buff,"%s+%d",s,addr-best);
  return buff;
}


void load_symbols ( FILE * f, int start, int end )
{
  char * symsect;
  char * p;
  char * sect_end;
  int addr;
  char * sym;
  
  fseek(f,start,SEEK_SET);
  symsect=palloc(end-start);
  fread(symsect,1,end-start,f);
  sect_end=symsect+(end-start);

  p=symsect;
  while (p<sect_end)
  {
    addr=*(int *)p;
    sym=p+4;
    addsymtotree(&syms,sym,addr,FALSE);
    p=p+4+((strlen(sym)+4)&~3);
  }
}


void print_profile_ii ( FILE * f, struct symtree * t )
{
  if (t)
  {
    print_profile_ii(f,t->right);
    if (strncmp(t->sym,"TI",2)==0)
    {
      fprintf(f,"%s %0.3f\n",t->sym,((double)code[t->addr])/CLOCKS_PER_SEC);
    } else {
      fprintf(f,"%s %d\n",t->sym,cprof[t->addr]);
    }
    print_profile_ii(f,t->left);
  }
}

void print_profile_i ( FILE * f )
{
  print_profile_ii(f,syms);
}


