/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: apasprintf.c,v 1.2 2000/11/08 14:48:58 bardslea Exp $


	Portable printf variants

	11 Jun 1999, AMULET Group
*/

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include <config.h>

#include "alloc.h"
#include "apasprintf.h"

#define LARD_APASPRINTF_BUFF_SIZE 65536

char buff[LARD_APASPRINTF_BUFF_SIZE];

void apasprintf (char **PTR, const char *TEMPLATE, ...)
{
  va_list ap;

  va_start(ap,TEMPLATE);
  vsnprintf(buff,LARD_APASPRINTF_BUFF_SIZE,TEMPLATE,ap);
  va_end(ap);
  if (*PTR)
  {
    (*PTR)=prealloc(*PTR,strlen(*PTR)+strlen(buff)+1);
    strcat(*PTR,buff);
  }
  else
  {
    (*PTR)=palloc(strlen(buff)+1);
    strcpy(*PTR,buff);
  }
}

#ifndef HAVE_SNPRINTF

int snprintf ( char * s, int n, char * fmt, ...)
{
  va_list ap;
  int r;

  va_start(ap,fmt);
  r=vsprintf(s,fmt,ap);
  va_end(ap);
  return r;
}

int vsnprintf ( char * s, const int n, const char * fmt, va_list ap )
{
  return(vsprintf(s,fmt,ap));
}

#endif

