/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: error.h,v 1.1.1.1 1999/07/15 18:47:29 bardslea Exp $


	Error message printing

	11 Jun 1999, AMULET Group
*/

#ifndef ERROR_HEADER
#define ERROR_HEADER

#include <stdarg.h>
#include <simple.h>

/* The symbols input_buffer, infilename and line_num must be
	provided by the program linked to liblard */
extern char * input_buffer;
extern char * infilename;
extern int line_num;

extern int yyerror(char *s)
#ifdef __GNUC__
  __attribute__ ((noreturn))
#endif
;

extern void fatal_error ( int linenum, char * fmt, ...)
#ifdef __GNUC__
  __attribute__ ((noreturn, format (printf,2,3)))
#endif
;

extern void fatal ( char * fmt, ...)
#ifdef __GNUC__
  __attribute__ ((noreturn, format (printf,1,2)))
#endif
;

extern void veryfatal ( char * msg );

extern void usage_error ( char * fmt, ...)
#ifdef __GNUC__
  __attribute__ ((noreturn, format (printf,1,2)))
#endif
;

extern void nonfatal_error ( int linenum, char * fmt, ...)
#ifdef __GNUC__
  __attribute__ ((format (printf,2,3)))
#endif
;

extern void internal_error ( char * fmt, ...)
#ifdef __GNUC__
  __attribute__ ((noreturn, format (printf,1,2)))
#endif
;

extern void debug ( bool doit, char * fmt, ...)
#ifdef __GNUC__
  __attribute__ ((format (printf,2,3)))
#endif
;

extern void ind_debug ( bool doit, int indent, char * fmt, ...)
#ifdef __GNUC__
  __attribute__ ((format (printf,3,4)))
#endif
;

#endif
