/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: lard_link.h,v 1.1 2000/04/26 00:55:29 bardslea Exp $


	Linker top level defns

	11 Jun 1999, AMULET Group
*/

#ifndef LINK_HEADER
#define LINK_HEADER

#include "simple.h"

struct chainrec
{
  int addr;
  struct chainrec * chain;
};

struct symtree
{
  char * sym;
  int addr;
  struct symtree * left;
  struct symtree * right;
  struct chainrec * chain;
};

void addsymtotree ( struct symtree * * t, char * sym, int addr,
                    bool allow_dups );

void readsymtree ( struct symtree * * init,  char * start, char * end,
                   int offset, bool allow_dups, char * symsuffix );

struct symtree * symtree_find_by_sym ( struct symtree * t, char * sym );
struct symtree * symtree_find_by_addr ( struct symtree * t, int addr );

extern struct symtree * lard_relocs;
extern struct symtree * lard_extsyms;
extern struct symtree * lard_intsyms;

extern char * lard_codesect;
extern int lard_codesectsize;

extern bool lard_link_verbose;
extern bool lard_estrip;
extern bool lard_istrip;
extern bool lard_norelocs;

void lard_link_load_file ( char * fn );
void lard_link_save_file ( char * fn );

extern int lard_relocsectsize;
extern char * lard_relocsect;

void add_reloc_out ( int addr, char * sym_name );

void llink ( void );

#endif
