/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: link.c,v 1.1 2000/04/26 00:55:29 bardslea Exp $


	Linker top level defns

	11 Jun 1999, AMULET Group
*/

#include <stdlib.h>
#include <unistd.h>

#include <alloc.h>
#include <error.h>
#include <simple.h>

#include "lard_link.h"

struct symtree * lard_relocs = NULL;
struct symtree * lard_extsyms = NULL;
struct symtree * lard_intsyms = NULL;

char * lard_codesect = NULL;
int lard_codesectsize = 0;

bool lard_link_verbose = FALSE;
bool lard_estrip = FALSE;
bool lard_istrip = FALSE;
bool lard_norelocs = FALSE;

void resolve_lard_relocs ( struct symtree * lard_relocs )
{
  struct symtree * esym;
  struct chainrec * c;
  
  if (!lard_relocs)
    return;

  esym=symtree_find_by_sym(lard_extsyms,lard_relocs->sym);

  if (!esym)
  {
    debug(lard_link_verbose || lard_norelocs,"%s is unresolved\n",lard_relocs->sym);
    add_reloc_out(lard_relocs->addr,lard_relocs->sym);
    c=lard_relocs->chain;
    while (c)
    {
      add_reloc_out(c->addr,lard_relocs->sym);
      c=c->chain;
    }
  } else
  {
    debug(lard_link_verbose,"Resolving %s\n",lard_relocs->sym);
    ((int *)lard_codesect)[lard_relocs->addr]=esym->addr-lard_relocs->addr+1;
    c=lard_relocs->chain;
    while (c)
    {
      ((int *)lard_codesect)[c->addr]=esym->addr-c->addr+1;
      c=c->chain;
    }
  }
  
  resolve_lard_relocs(lard_relocs->left);
  resolve_lard_relocs(lard_relocs->right);
}


void lard_link_dump(struct symtree * t)
{
  if (t)
  {
    lard_link_dump(t->left);
    debug(lard_link_verbose,"%d %s\n",t->addr,t->sym);
    lard_link_dump(t->right);
  }
}

void llink ( void )
{
/*  debug(verbose,"Relocs=\n");
  dump(lard_relocs); */
  
  resolve_lard_relocs(lard_relocs);
}
