#!/bin/sh
exec perl -w -x $0 ${1+"$@"}
    if 0;

#!perl

foreach $i ("channels.l","channels_chk.l","pwrchannels.l","channels_tvec.l",
	"channels_vcd.l")
{
    open OUTF,">$i";

    print OUTF "
/* $i */
/* Automatically generated by channels.pl - do not edit */

/* Channel communication library */

use (io) .

chan_id:var(int).
chan_trace_thisone:var(bool).
";
if ($i eq "channels_tvec.l") {
print OUTF "
tvec_trace_thisone:var(bool).
tvec_next_vec_time:var(int).
tvec_vecinterval:var(int).
" };	
if ($i eq "channels_vcd.l") {
print OUTF "
vcd_file:var(tfile).
vcd_last_message_time:var(int).
vcd_default_format:var(string).
" };	
print OUTF "
channels : lib = (

  chan(T:type):type=record(v::T,		/* value */

";
if ($i eq "channels_chk.l") {
print OUTF "                    magic::int,          /* magic number */
" };
if ($i eq "pwrchannels.l") {
print OUTF "                    pwr::int,          /* power used in this channel */
                                pwrvar::string,    /* name of power variable */
" };
if ($i eq "channels_tvec.l") {
print OUTF "                   vecs::bool,        /* make vectors? */
                           vec_mode::int,       /* cycle count of vector gen */
" };	
print OUTF "

                           s::bool,		/* status */
                           rtid::int,           /* tid of receiver */
                           stid::int,           /* tid of sender */
";
if ($i ne "channels_vcd.l") {
print OUTF "
                           traced::bool,       /* traced? */
                           stime::int,          /* time sender started */
                           rtime::int,          /* time receiver started */
                           datacmd::string,     /* tcl cmd for new data */
                           timescmd::string     /* tcl cmd for new times */
" } else {
print OUTF "
                           format::string,        /* display format string */
                           id::int                /* channel id */
" };
print OUTF "
                           ).       /* name */

  init_chan : overloaded .

  init_chan(C:var(chan(T:type)),name:val(string),format:val(string)) : expr(void) = (
    i:var(int).
    sz:var(int).
    id:var(string).

    newstringvalparam(name);
    newstringvalparam(format);
    newstringvar(id);

";
if ($i eq "channels_chk.l") {
print OUTF "C->magic:=16#42424242;
" };
print OUTF "

    C->s:=false;
    C->rtid:=0;
    C->stid:=0;
    sz:=sizeof_type(T)/sizeof_type(int);
";
if ($i eq "channels_vcd.l") {
print OUTF "
	chan_id := chan_id + 1;
    C->id := chan_id;
    id := i2s (C->id);

    newstringvar(C->format);
	if (format = \"\") then ( C->format := vcd_default_format )
	else ( C->format := format );
    (
        fullname : var(string) .
        newstringvar (fullname);
        fullname := tcl_cmd_str (\"blockname {.}\") \@ \".\" \@ name;
	/* fullname := name; */
        fprintstr (vcd_file, \"\$var reg 1 1\" \@ id \@ \" <\" \@ fullname \@ \"_hs> \$end\\n\");
        fprintstr (vcd_file, \"\$var reg 1 2\" \@ id \@ \" <\" \@ fullname \@ \"_rcv> \$end\\n\");
        if (now != vcd_last_message_time) then
        (
            fprintstr (vcd_file, \"\#\" \@ now \@ \"\\n\");
            vcd_last_message_time := now
        );
        fprintstr (vcd_file, \"01\" \@ id \@ \"\\n\");
        fprintstr (vcd_file, \"02\" \@ id \@ \"\\n\");
        if (sz != 0) then
            fprintstr (vcd_file, \"\$var real 1 3\" \@ id \@ \" <\" \@ fullname \@ \"_data> \$end\\n\");
        endstringvar (fullname)
    )
" } else {
print OUTF "
	if (format = \"\") then
	(
		tcl_cmd_noerr(\"global chan_default_format\\\nchan_new {\"\@name\@\"} \"\@i2s(sz)\@\" \\\"\"\@
		\"\$chan_default_format\"\@\"\\\"\")
	) else (
    	tcl_cmd_noerr(\"chan_new {\"\@name\@\"} \"\@i2s(sz)\@\" \\\"\"\@format\@\"\\\"\")
	);
    id:=i2s(chan_id);

    if (chan_id>=0 && sz!=0) then (
      forseq i in 0 to sz-1 do (
        cast(int^read(sz),C->v)[i]:=0;
        export_var(cast(int^read(sz),C->v)[i],\"chan_data_c\"\@id\@\"_\"\@i2s(i))
      )
    );

    newstringvar(C->datacmd);
    C->datacmd:=\"chan_data c\"\@id;
    newstringvar(C->timescmd);
    C->timescmd:=\"chan_times c\"\@id;
    C->stime:=0;
    C->rtime:=0;
    export_var(C->stime,\"chan_stime_c\"\@id);
    export_var(C->rtime,\"chan_rtime_c\"\@id);
" };
if ($i eq "pwrchannels.l") {
print OUTF "
    C->pwr:=0;
    newstringvar(C->pwrvar);
    C->pwrvar:=\"chan_pwr_c\"\@id;
    export_var(C->pwr,C->pwrvar);
" };
if ($i eq "channels_tvec.l") {
print OUTF "
    C->vecs:=tvec_trace_thisone;
    export_var(C->vecs,\"::tvec::traced_c\"\@id);
    C->vec_mode:=0;
    export_var(C->vec_mode,\"::tvec::chanmode_c\"\@id);
" };	
if ($i ne "channels_vcd.l") {
print OUTF "
    C->traced:=chan_trace_thisone;
    export_var(C->traced,\"chan_traced_c\"\@id)
" };
print OUTF "
  ).

  init_chan(C:var(chan(T:type)),name:val(string)) : expr(void) = (
    init_chan(C,name,\"\")
  ).

  init_chan(C:var(chan(T:type))) : expr(void) = (

";
if ($i eq "channels_chk.l") {
print OUTF "C->magic:=16#42424242;
" };
if ($i eq "pwrchannels.l") {
print OUTF "C->pwr:=-1;
      newstringvar(C->pwrvar);
" };
print OUTF "

      C->s:=false;
      C->rtid:=0;
      C->stid:=0";
if ($i ne "channels_vcd.l") {
print OUTF ";
      C->traced:=false;
      newstringvar(C->datacmd);
      newstringvar(C->timescmd)
" };
if ($i eq "channels_tvec.l") {
printf OUTF "
      C->vecs:=false;
" };
print OUTF "
  ).

  /* receive */
  _?_ : infix(60,right).
  (c:var(chan(Tc:type))) ? (e:expr(Te:type)) : expr(Te) = (
    r:var(Te).

";
if ($i eq "channels_chk.l") {
print OUTF "if (c->magic!=16#42424242) then (
    warning(lardpos@\": uninitialised channel\");
    init_chan(c)
);
" };
if ($i ne "channels_vcd.l") {
print OUTF "
    c->rtime:=now;
" } else {
print OUTF "
    if (now != vcd_last_message_time) then
    (
	fprintstr (vcd_file, \"\#\" \@ now \@ \"\\n\");
        vcd_last_message_time := now
    );
    fprintstr (vcd_file, \"x2\" \@ c->id \@ \"\\n\");
" };
print OUTF "
    if (!c->s) then (
      c->rtid:=mytid;
      setmypriority(PRI_SUSP);
      promote_waits;
      yield
    );
    r:=e;
";
if ($i eq "channels_tvec.l") {
printf OUTF "
    if (c->vecs) then (
        c->vec_mode:=2;
        wait_for(tvec_next_vec_time-now);
        c->vec_mode:=0
    );
" };
printf OUTF "
    c->s:=false;
    setpriority(c->stid,PRI_RUN);
    c->rtid:=0;
    r
  ).

  /* read received value */
  ?_ : infix(200,none).
  ? (c:var(chan(TT:type))) : expr(TT) = (
    c->v
  ).

  /* send */
  _!_ : infix(70,none).
  (c:var(chan(Tp:type))) ! (v:val(Tp)) : expr(void) = (

";
if ($i eq "channels_chk.l") {
print OUTF "if (c->magic!=16#42424242) then (
    warning(lardpos@\": uninitialised channel\");
    init_chan(c)
);
" };
if ($i eq "pwrchannels.l") {
print OUTF "
    if (c->pwr!=-1) then (
      c->pwr := c->pwr + bitsdiff(c->v,v);
      update_export_var(c->pwrvar)
    );
" };
if ($i ne "channels_vcd.l") {
print OUTF "
    c->stime:=now;
" } else {
print OUTF "
    if (now != vcd_last_message_time) then
    (
	fprintstr (vcd_file, \"\#\" \@ now \@ \"\\n\");
        vcd_last_message_time := now
    );
    fprintstr (vcd_file, \"11\" \@ c->id \@ \"\\n\");
" };
print OUTF "
    c->v:=v;
";
if ($i eq "channels_tvec.l") {
printf OUTF "
    if (c->vecs) then (
        c->vec_mode:=1;
        wait_for(tvec_next_vec_time-now);
        c->vec_mode:=0
    );
" };	
printf OUTF "
    c->s:=true;
    if (c->rtid!=0) then setpriority(c->rtid,PRI_RUN);
";
if ($i ne "channels_vcd.l") {
print OUTF "
    if c->traced
    then (
      tcl_cmd(c->datacmd)
    );
" } else {
print OUTF "
    if (sizeof_type (Tp) != 0) then (
        if (now != vcd_last_message_time) then
        (
	    fprintstr (vcd_file, \"\#\" \@ now \@ \"\\n\");
            vcd_last_message_time := now
        );
        fprintstr (vcd_file, \"s\" \@ formatdata (c->format, v) \@ \" 3\" \@ c->id \@ \"\\n\")
    );
" };
print OUTF "
    c->stid:=mytid;
    setmypriority(PRI_SUSP);
    promote_waits;
    yield;
";
if ($i ne "channels_vcd.l") {
print OUTF "
    if c->traced
    then (
      tcl_cmd(c->timescmd)
    )
" } else {
print OUTF "
    if (now != vcd_last_message_time) then
    (
        fprintstr (vcd_file, \"\#\" \@ now \@ \"\\n\");
        vcd_last_message_time := now
    );
    fprintstr (vcd_file, \"01\" \@ c->id \@ \"\\n\");
    fprintstr (vcd_file, \"02\" \@ c->id \@ \"\\n\")
" };
print OUTF "
  ).

  /* peek without reading */
  chan_peek(c:var(chan(T:type))) : expr(T) = (
      c->v
  ).

  /* check if data is available */
  chan_ready(c:var(chan(T:type))) : expr(bool) = (
      c->s
  ).

  /* Select function */
  select:varargs.

  select2(c1:var(chan(T1:type)),c2:var(chan(T2:type))):expr(int)=(
    wait_until(chan_ready(c1)||chan_ready(c2));
    if (chan_ready(c1)) then 1 else 2
  ).

  select3(c1:var(chan(T1:type)),c2:var(chan(T2:type)),
          c3:var(chan(T3:type))):expr(int)=(
    wait_until(chan_ready(c1)||chan_ready(c2)
               ||chan_ready(c3));
    if (chan_ready(c1)) then 1
    else if (chan_ready(c2)) then 2
    else 3
  ).

  select4(c1:var(chan(T1:type)),c2:var(chan(T2:type)),
          c3:var(chan(T3:type)),c4:var(chan(T4:type))):expr(int)=(
    wait_until(chan_ready(c1)||chan_ready(c2)
               ||chan_ready(c3)||chan_ready(c4));
    if (chan_ready(c1)) then 1
    else if (chan_ready(c2)) then 2
    else if (chan_ready(c3)) then 3
    else 4
  ).

  select5(c1:var(chan(T1:type)),c2:var(chan(T2:type)),
          c3:var(chan(T3:type)),c4:var(chan(T4:type)),
          c5:var(chan(T5:type))):expr(int)=(
    wait_until(chan_ready(c1)||chan_ready(c2)
               ||chan_ready(c3)||chan_ready(c4)
               ||chan_ready(c5));
    if (chan_ready(c1)) then 1
    else if (chan_ready(c2)) then 2
    else if (chan_ready(c3)) then 3
    else if (chan_ready(c4)) then 4
    else 5
  ).

  islib).

";
if ($i eq "channels_tvec.l") {
printf OUTF "
mkvectors:expr(void) = (
  tcl_cmd(\"::tvec::mkfirstvector\");
  wait_for(tvec_vecinterval-1);
  forever(
    tvec_next_vec_time:=tvec_next_vec_time+tvec_vecinterval;
    tcl_cmd(\"::tvec::mkvector\");
    promote_waits;
    wait_for(tvec_vecinterval)
  )
).

vec_tid:var(int).

" };	

printf OUTF "
chan_id:=-1;
";
if ($i ne "channels_vcd.l") {
print OUTF "
export_var(chan_id,\"chan_id\");
" };
if ($i eq "channels_tvec.l") {
printf OUTF "
export_var(tvec_trace_thisone,\"::tvec::trace_thisone\");
tvec_trace_thisone:=false;
export_var(tvec_vecinterval,\"::tvec::vecinterval\");
tvec_vecinterval:=1000;
tvec_next_vec_time:=tvec_vecinterval;
" };	
if ($i ne "channels_vcd.l") {
print OUTF "
export_var(chan_trace_thisone,\"chan_trace_thisone\");
chan_trace_thisone:=false
" } else {
print OUTF "
vcd_file := stderr;
vcd_last_message_time := -1;
newstringvar(vcd_default_format);
vcd_default_format := \"\%* d\"
" };
if ($i eq "channels_tvec.l") {
print OUTF "
;
vec_tid:=spawn(\"vector generator\" is mkvectors,0)
" };
}
