/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: cmdline_args.l,v 1.1.1.1 1999/07/15 18:47:49 bardslea Exp $


	Library to enable the use of arguments to the lard instead of just to the interpreter

	11 Jun 1999, AMULET Group
*/

use(io).
  
cmdline_args:lib=(
  
  cmdline_args_i:var(int).
  argc:var(int).
  argv:var(string^256).
  
  cmdline_args_initialise() : expr(void) = (
    argc:=0;
    forseq cmdline_args_i in 0 to 255 do (
      newstringvar(argv[cmdline_args_i]);
      argv[cmdline_args_i]:=""
    );
    
    argc:=tcl_cmd_int("llength $::lard::arguments");
    if (argc > 255) then (
      fprintstr(stderr, "warning: may not pass more than 255 arguments to the lard program");
      argc:=255
    );
    
    if (argc != 0) then (
      printstr(i2s(argc) @ " lard arguments: ");
      forseq cmdline_args_i in 0 to (argc-1) do (
        argv[cmdline_args_i]:=tcl_cmd_str("lindex $::lard::arguments " @ i2s(cmdline_args_i));
        printstr(argv[cmdline_args_i] @ " ")
      );
      printstr("\n")
    )
  ).
  
  islib
).

/*------------------------------------------------------------------*/

use(cmdline_args).

cmdline_args_initialise();

(null)

/*------------------------------------------------------------------*/
