/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: mpint.l,v 1.4 2000/10/22 23:57:20 bardslea Exp $


    Multi-precision int library additions

	11 Jun 1999, AMULET Group
*/

use (io) .

mpint : type .

mpint_cmp_t : type = scalar .
cmp_less_than : val(mpint_cmp_t) .
cmp_equal : val(mpint_cmp_t) .
cmp_greater_than: val(mpint_cmp_t) .

mpint_init : expr(mpint) .
mpint_clear (arg:val(mpint)) : expr(void) .

mpint_set (mp:val(mpint),mpvalue:val(mpint)) : expr(void) .
mpint_set_ui (mp:val(mpint),value:val(int)) : expr(void) .
mpint_set_si (mp:val(mpint),value:val(int)) : expr(void) .
mpint_set_str (mp:val(mpint),str:val(string),base:val(int)) : expr(void) .

mpint_copy (mp:val(mpint)) : expr(mpint) .

mpint_get_ui (mp:val(mpint)) : expr(int) .
mpint_get_si (mp:val(mpint)) : expr(int) .
mpint_get_str (mp:val(mpint),base:val(int)) : expr(string) .

mpint_out_str (stream:val(tfile),base:val(int),mp:val(mpint)) : expr(int) .
mpint_inp_str (stream:val(tfile),base:val(int),mp:val(mpint)) : expr(int) .
mpint_out_raw (stream:val(tfile),mp:val(mpint)) : expr(int) .
mpint_inp_raw (stream:val(tfile),mp:val(mpint)) : expr(int) .

mpint_add (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) . 
mpint_add_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) . 
mpint_sub (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) . 
mpint_sub_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) . 
mpint_mul (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) . 
mpint_mul_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) . 
mpint_mul_2exp (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) . 
mpint_neg (result:val(mpint),arg:val(mpint)) : expr(void) . 
mpint_abs (result:val(mpint),arg:val(mpint)) : expr(void) . 
mpint_fac_ui (result:val(mpint),arg:val(mpint)) : expr(void) . 

mpint_tdiv_q (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_tdiv_q_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_tdiv_r (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_tdiv_r_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_tdiv_qr (quo:val(mpint),rem:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_tdiv_qr_ui (quo:val(mpint),rem:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_fdiv_q (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_fdiv_q_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_fdiv_r (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_fdiv_r_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(int) .
mpint_fdiv_qr (quo:val(mpint),rem:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_fdiv_qr_ui (quo:val(mpint),rem:val(mpint),left:val(mpint),right:val(int)) : expr(int) .
mpint_fdiv_ui (left:val(mpint),right:val(int)) : expr(int) .
mpint_cdiv_q (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_cdiv_q_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_cdiv_r (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_cdiv_r_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(int) .
mpint_cdiv_qr (quo:val(mpint),rem:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_cdiv_qr_ui (quo:val(mpint),rem:val(mpint),left:val(mpint),right:val(int)) : expr(int) .
mpint_cdiv_ui (left:val(mpint),right:val(int)) : expr(int) .
mpint_mod (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_mod_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_divexact (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_tdiv_q_2exp (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_tdiv_r_2exp (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_fdiv_q_2exp (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_fdiv_r_2exp (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_powm (result:val(mpint),base:val(mpint),expo:val(mpint),modu:val(mpint)) : expr(void) .
mpint_powm_ui (result:val(mpint),base:val(mpint),expo:val(int),modu:val(mpint)) : expr(void) .
mpint_pow_ui (result:val(mpint),base:val(mpint),expo:val(int)) : expr(void) .
mpint_ui_pow_ui (result:val(mpint),base:val(int),expo:val(int)) : expr(void) .
mpint_sqrt (result:val(mpint),arg:val(mpint)) : expr(void) .
mpint_sqrtrem (result:val(mpint),rem:val(mpint),arg:val(mpint)) : expr(void) .
mpint_perfect_square_p (arg:val(mpint)) : expr(bool) .
mpint_probab_prime_p (arg:val(mpint),reps:val(int)) : expr(bool) .
mpint_gcd (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) .
mpint_gcd_ui (result:val(mpint),left:val(mpint),right:val(int)) : expr(void) .
mpint_gcdext (g:val(mpint),s:val(mpint),t:val(mpint),a:val(mpint),b:val(mpint)) : expr(void) .
mpint_invert (result:val(mpint),arg:val(mpint),modu:val(mpint)) : expr(void) .
mpint_jacobi (result:val(mpint),arg:val(mpint)) : expr(void) .
mpint_legendre (result:val(mpint),arg:val(mpint)) : expr(void) .

mpint_cmp (left:val(mpint),right:val(mpint)) : expr(mpint_cmp_t) .
mpint_cmp_ui (left:val(mpint),right:val(int)) : expr(mpint_cmp_t) .
mpint_cmp_si (left:val(mpint),right:val(int)) : expr(mpint_cmp_t) .
mpint_sgn (arg:val(mpint)) : expr(mpint_cmp_t) .

mpint_and (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) . 
mpint_ior (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) . 
mpint_xor (result:val(mpint),left:val(mpint),right:val(mpint)) : expr(void) . 
mpint_com (result:val(mpint),arg:val(mpint)) : expr(void) . 
mpint_popcount (arg:val(mpint)) : expr(int) . 
mpint_hamdist (arg1:val(mpint),arg2:val(mpint)) : expr(int) . 
mpint_scan0 (arg:val(mpint),bitNo:val(int)) : expr(int) . 
mpint_scan1 (arg:val(mpint),bitNo:val(int)) : expr(int) . 
mpint_setbit (arg:val(mpint),bitNo:val(int)) : expr(void) . 
mpint_clrbit (arg:val(mpint),bitNo:val(int)) : expr(void) . 

mpint_random (result:val(mpint),size:val(int)) : expr(void) .
mpint_random2 (result:val(mpint),size:val(int)) : expr(void) .
mpint_size (arg:val(mpint)) : expr(int) .
mpint_sizeinbase (arg:val(mpint),base:val(int)) : expr(int) .

/* int <-> mpint ops, don't consume */

mpint2i (i:val(mpint)) : expr(int) = (
	mpint_get_ui (i)
) .

mpint2si (i:val(mpint)) : expr(int) = (
	mpint_get_si (i)
) .

i2mpint (i:val(int)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, i);
	ret
) .

si2mpint (i:val(int)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_si (ret, i);
	ret
) .

/* Overloaded operations, NB. these consume their arguments */

- (a:val(mpint)) : expr(mpint) = (
	mpint_neg (a, a);
	a
) .

(a:val(mpint)) + (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := a;
	mpint_add (ret, a, b);
	mpint_clear (b);
	ret
) .

(a:val(mpint)) - (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := a;
	mpint_sub (ret, a, b);
	mpint_clear (b);
	ret
) .

(a:val(mpint)) * (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := a;
	mpint_mul (ret, a, b);
	mpint_clear (b);
	ret
) .

(a:val(mpint)) / (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := a;
	mpint_tdiv_q (ret, a, b);
	mpint_clear (b);
	ret
) .

(a:val(mpint)) mod (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := a;
	mpint_mod (ret, a, b);
	mpint_clear (b);
	ret
) .

abs (a:val(mpint)) : expr(mpint) = (
	mpint_abs (a, a);
	a
) .

/* NB. min and max don't consume arguments */

min (a:val(mpint),b:val(mpint)) : expr(mpint) = (
	if mpint_cmp (a, b) = cmp_less_than
	then a else b
) .

max (a:val(mpint),b:val(mpint)) : expr(mpint) = (
	if mpint_cmp (a, b) = cmp_greater_than
	then a else b
) .

not (a:val(mpint)) : expr(mpint) = (
	mpint_com (a, a);
	a
) .

(a:val(mpint)) and (b:val(mpint)) : expr(mpint) = (
	mpint_and (a, a, b);
	mpint_clear (b);
	a
) .

(a:val(mpint)) or (b:val(mpint)) : expr(mpint) = (
	mpint_ior (a, a, b);
	mpint_clear (b);
	a
) .

(a:val(mpint)) xor (b:val(mpint)) : expr(mpint) = (
	mpint_xor (a, a, b);
	mpint_clear (b);
	a
) .

(a:val(mpint)) << (b:val(mpint)) : expr(mpint) = (
	mpint_mul_2exp (a, a, mpint_get_ui (b));
	mpint_clear (b);
	a
) .

(a:val(mpint)) >> (b:val(mpint)) : expr(mpint) = (
	mpint_tdiv_q_2exp (a, a, mpint_get_ui (b));
	mpint_clear (b);
	a
) .

bitsdiff (a:val(mpint),b:val(mpint)) : expr(int) = (
	ret : var(int) .
	ret := mpint_hamdist (a, b);
	mpint_clear (a);
	mpint_clear (b);
	ret
) .

mpint_cmp_consume (a:val(mpint),b:val(mpint)) : expr(mpint_cmp_t) = (
	ret : var(mpint_cmp_t) .
	ret := mpint_cmp (a, b);
	mpint_clear (a);
	mpint_clear (b);
	ret
) .

(a:val(mpint)) < (b:val(mpint)) : expr(bool) = (
	mpint_cmp_consume (a, b) = cmp_less_than
) .

(a:val(mpint)) <= (b:val(mpint)) : expr(bool) = (
	mpint_cmp_consume (a, b) != cmp_greater_than
) .

(a:val(mpint)) = (b:val(mpint)) : expr(bool) = (
	mpint_cmp_consume (a, b) = cmp_equal
) .

(a:val(mpint)) != (b:val(mpint)) : expr(bool) = (
	mpint_cmp_consume (a, b) != cmp_equal
) .

(a:val(mpint)) >= (b:val(mpint)) : expr(bool) = (
	mpint_cmp_consume (a, b) != cmp_less_than
) .

(a:val(mpint)) > (b:val(mpint)) : expr(bool) = (
	mpint_cmp_consume (a, b) = cmp_greater_than
) .

/* mpint x int operations unsigned! */

(a:val(mpint)) + (b:val(int)) : expr(mpint) = (
	mpint_add_ui (a, a, b);
	a
) .

(a:val(mpint)) - (b:val(int)) : expr(mpint) = (
	mpint_sub_ui (a, a, b);
	a
) .

(a:val(mpint)) * (b:val(int)) : expr(mpint) = (
	mpint_mul_ui (a, a, b);
	a
) .

(a:val(mpint)) / (b:val(int)) : expr(mpint) = (
	mpint_tdiv_q_ui (a, a, b);
	a	
) .

(a:val(mpint)) mod (b:val(int)) : expr(mpint) = (
	sink (mpint_mod_ui (a, a, b));
	a
) .

/* NB. min and max don't consume arguments */

min (a:val(mpint),b:val(int)) : expr(mpint) = (
	if mpint_cmp_ui (a, b) = cmp_less_than
	then a else i2mpint (b)
) .

max (a:val(mpint),b:val(int)) : expr(mpint) = (
	if mpint_cmp_ui (a, b) = cmp_greater_than
	then a else i2mpint (b)
) .

(a:val(mpint)) and (b:val(int)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, b);
	mpint_and (ret, a, ret);
	mpint_clear (a);
	ret
) .

(a:val(mpint)) or (b:val(int)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, b);
	mpint_ior (ret, a, ret);
	mpint_clear (a);
	ret
) .

(a:val(mpint)) xor (b:val(int)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, b);
	mpint_xor (ret, a, ret);
	mpint_clear (a);
	ret
) .

(a:val(mpint)) << (b:val(int)) : expr(mpint) = (
	mpint_mul_2exp (a, a, b);
	a
) .

(a:val(mpint)) >> (b:val(int)) : expr(mpint) = (
	mpint_tdiv_q_2exp (a, a, b);
	a	
) .

bitsdiff (a:val(mpint),b:val(int)) : expr(int) = (
	ret : var(int) .
	tmp : var(mpint) .
	tmp := mpint_init;
	mpint_set_ui (tmp, b);
	ret := mpint_hamdist (a, tmp);
	mpint_clear (tmp);
	mpint_clear (a);
	ret
) .

mpint_cmp_ui_consume (a:val(mpint),b:val(int)) : expr(mpint_cmp_t) = (
	ret : var(mpint_cmp_t) .
	ret := mpint_cmp_ui (a, b);
	mpint_clear (a);
	ret
) .

(a:val(mpint)) < (b:val(int)) : expr(bool) = (
	mpint_cmp_ui_consume (a, b) = cmp_less_than
) .

(a:val(mpint)) <= (b:val(int)) : expr(bool) = (
	mpint_cmp_ui_consume (a, b) != cmp_greater_than
) .

(a:val(mpint)) = (b:val(int)) : expr(bool) = (
	mpint_cmp_ui_consume (a, b) = cmp_equal
) .

(a:val(mpint)) != (b:val(int)) : expr(bool) = (
	mpint_cmp_ui_consume (a, b) != cmp_equal
) .

(a:val(mpint)) >= (b:val(int)) : expr(bool) = (
	mpint_cmp_ui_consume (a, b) != cmp_less_than
) .

(a:val(mpint)) > (b:val(int)) : expr(bool) = (
	mpint_cmp_ui_consume (a, b) = cmp_greater_than
) .

/* int x mpint operations */

(a:val(int)) + (b:val(mpint)) : expr(mpint) = ( b + a ) .
(a:val(int)) * (b:val(mpint)) : expr(mpint) = ( b * a ) .
(a:val(int)) and (b:val(mpint)) : expr(mpint) = ( b and a ) .
(a:val(int)) or (b:val(mpint)) : expr(mpint) = ( b or a ) .
bitsdiff (a:val(int),b:val(mpint)) : expr(int) = ( bitsdiff (b, a) ) .

(a:val(int)) - (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, a);
	mpint_sub (ret, ret, b);
	mpint_clear (b);
	ret
) .

(a:val(int)) / (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, a);
	mpint_tdiv_q (ret, ret, b);
	mpint_clear (b);
	ret
) .

(a:val(int)) mod (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, a);
	mpint_mod (ret, ret, b);
	mpint_clear (b);
	ret
) .

/* NB. min and max don't consume arguments */

min (a:val(int),b:val(mpint)) : expr(mpint) = (
	if mpint_cmp_ui (b, a) = cmp_greater_than
	then i2mpint (a) else b
) .

max (a:val(int),b:val(mpint)) : expr(mpint) = (
	if mpint_cmp_ui (b, a) = cmp_less_than
	then i2mpint (a) else b
) .

(a:val(int)) << (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, a);
	mpint_mul_2exp (ret, ret, mpint_get_ui (b));
	mpint_clear (b);
	ret
) .

(a:val(int)) >> (b:val(mpint)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_ui (ret, a);
	mpint_tdiv_q_2exp (ret, ret, mpint_get_ui (b));
	mpint_clear (b);
	ret
) .

(a:val(int)) < (b:val(mpint)) : expr(bool) = (
	mpint_cmp_ui_consume (b, a) = cmp_greater_than
) .

(a:val(int)) <= (b:val(mpint)) : expr(bool) = (
	mpint_cmp_ui_consume (b, a) != cmp_less_than
) .

(a:val(int)) = (b:val(mpint)) : expr(bool) = (
	mpint_cmp_ui_consume (b, a) = cmp_equal
) .

(a:val(int)) != (b:val(mpint)) : expr(bool) = (
	mpint_cmp_ui_consume (b, a) != cmp_equal
) .

(a:val(int)) >= (b:val(mpint)) : expr(bool) = (
	mpint_cmp_ui_consume (b, a) != cmp_greater_than
) .

(a:val(int)) > (b:val(mpint)) : expr(bool) = (
	mpint_cmp_ui_consume (b, a) = cmp_less_than
) .

/* I/O operations, these consume parameters */

fprintmpint (f:val(tfile),n:val(mpint)) : expr(void) = (
	sink (mpint_out_str (f, 10, n));
	mpint_clear (n)
) .

freadmpint (f:val(tfile)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	sink (mpint_inp_str (f, 10, ret));
	ret
) .

printmpint (n:val(mpint)) : expr(void) = (
	fprintmpint (stdout, n)
) .

fprintmpinthex (f:val(tfile),n:val(mpint)) : expr(void) = (
	sink (mpint_out_str (f, 16, n));
	mpint_clear (n)
) .

printmpinthex (n:val(mpint)) : expr(void) = (
	sink (mpint_out_str (stdout, 16, n));
	mpint_clear (n)
) .

print1 (n:val(mpint)) : expr(void) = (
	printmpint (n)
) .

/* String operations, don't consume */

mpint2s (i:val(mpint)) : expr(string) = (
	mpint_get_str (i, 10)
) .

mpint2hex (i:val(mpint)) : expr(string) = (
	mpint_get_str (i, 16)
) .

s2mpint (s:val(string)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	sink (parsedata ("%mi", s, ret));
	ret
) .

hex2mpint (s:val(string)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_str (ret, s, 16);
	ret
) .

oct2mpint (s:val(string)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_str (ret, s, 8);
	ret
) .

bin2mpint (s:val(string)) : expr(mpint) = (
	ret : var(mpint) .
	ret := mpint_init;
	mpint_set_str (ret, s, 2);
	ret
) .

/* Bit/bitfield extraction, these don't consume arguments */

(v:val(mpint)) [ (i:val(int)) ] : expr(int) = (
	tmp : var(mpint) .
	ret : var(int) .
	tmp := mpint_init;
	mpint_tdiv_q_2exp (tmp, v, i);
	ret := mpint_cdiv_ui (tmp, 2);
	mpint_clear (tmp);
	ret
) .

bitmask (mask:val(mpint),r:val(range(int))) : expr(void) =
(
	mpint_set_ui (mask, 0);
	mpint_setbit (mask, rangewidth (r));
	mpint_sub_ui (mask, mask, 1);
	if (min (r) != 0) then ( mpint_mul_2exp (mask, mask, min (r)) )
) .

bitmask (r:val(range(int))) : expr(mpint) =
(
	mask : var(mpint) .
	mask := mpint_init;
	bitmask (mask, r);
	mask
) .

bitfield (v:val(mpint),r:val(range(int))) : expr(mpint) =
(
	mask : var(mpint) .
	mask := bitmask (r);
	mpint_and (mask, v, mask);
	
	mask >> min(r)
) .

/* Consumes! */
(v:val(mpint)) [ (r:val(range(int))) ] : expr(mpint) = (
	(bitmask(r) and v) >> min(r)
) .

setbit (v:val(mpint),i:val(int)) : expr(void) = (
	mpint_setbit(v,i)
).

signextend (value:val(mpint),width:val(int)) : expr(mpint) =
(
	masked : var(mpint) .
	masked := bitmask(width-1 to 0) and value;
	if masked[width - 1] = 0
	then masked
	else (
		zero : var(mpint) .
		zero := mpint_init;
		mpint_setbit(zero,width);
		masked - zero
	) 
) .

null
