#!/bin/sh
exec perl -w -x $0 ${1+"$@"}
    if 0;

#!perl

foreach $i ("signals.l","signals_tvec.l")
{
    open OUTF,">$i";

    print OUTF "
/* $i */
/* Automatically generated by signals.pl - do not edit */

sig_id:var(int).
sig_trace_thisone:var(bool).

signals:lib=(
  
  sig(T:type):type=record(
                     v::T,            /* current value of the signal */
                     wait_tid::int,   /* tid of a thread to activate when
                                         value changes */
                     traced::bool,    /* traced? */
";
if ($i eq "signals_tvec.l") {
printf OUTF "
                     vecs::bool,      /* make vectors? */
";
}
print OUTF "
                     datacmd::string  /* tcl cmd for new data */
                   ).
  
  setsig(s:var(sig(T:type)),v:val(T)):expr(void)=(
    
    s->v:=v;
";
if ($i eq "signals_tvec.l") {
printf OUTF "
    if (s->vecs) then (
      wait_for(tvec_next_vec_time-now)
    );
";
}
print OUTF "
    if (s->traced) then tcl_cmd(s->datacmd);
    if (s->wait_tid!=0) then (
      setpriority(s->wait_tid,PRI_RUN);
      s->wait_tid:=0
    )
  ).

  readsig(s:var(sig(T:type))):expr(T)=(
    s->v
  ).

  init_sig:overloaded.

  init_sig(s:var(sig(T:type)),name:val(string)):expr(void)=(
    i:var(int).
    sz:var(int).
    id:var(string).

    newstringvalparam(name);
    newstringvar(id);
    s->wait_tid:=0;
    sz:=sizeof_type(T)/sizeof_type(int);
    tcl_cmd_noerr(\"sig_new {\"\@name\@\"} \"\@i2s(sz));
    id:=i2s(sig_id);
    if sz!=0 then (
      forseq i in 0 to sz-1 do (
        cast(int^read(sz),s->v)[i]:=0;
        export_var(cast(int^read(sz),s->v)[i],\"sig_data_s\"\@id\@\"_\"\@i2s(i))
      )
    );
    newstringvar(s->datacmd);
    s->datacmd:=\"sig_data s\"\@id;
    s->traced:=sig_trace_thisone;
    export_var(s->traced,\"sig_traced_s\"\@id);
";
if ($i eq "signals_tvec.l") {
printf OUTF "
    s->vecs:=tvec_trace_thisone;
    export_var(s->vecs,\"::tvec::traced_s\"\@id);
";
}
print OUTF "
    endstringvalparam(name);
    endstringvar(id)
  ).


  init_sig(s:var(sig(T:type))):expr(void)=(

    s->wait_tid:=0;
    s->traced:=false;
";
if ($i eq "signals_tvec.l") {
printf OUTF "
    s->vecs:=false;
";
}
print OUTF "
    newstringvar(s->datacmd)
  ).



  wait_on(s:var(sig(T:type))):expr(void)=(
    previous_wait_tid:var(int).
    previous_wait_tid:=s->wait_tid;
    s->wait_tid:=mytid;
    setmypriority(PRI_SUSP);
    yield;
    if (previous_wait_tid!=0) then (
      setpriority(previous_wait_tid,PRI_RUN)
    )
  ).

  islib
  
).


export_var(sig_id,\"sig_id\");
export_var(sig_trace_thisone,\"sig_trace_thisone\");
sig_id:=0;
sig_trace_thisone:=false


";


}

