/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: time.l,v 1.3 2002/10/24 12:24:46 janinl Exp $


	LARD time functions

	11 Jun 1999, AMULET Group
*/

use(io).

now:var(int).
perpetual:var(bool).
next_time:var(int).
cosimulation_activated:var(bool).

regtime(tid:val(int),time:val(int)):expr(void).
nexttime(perp:val(bool),cosim:val(bool)):expr(int).
cosimulation_cmd(cmd:val(string),T:type):expr(T).

advance_time : expr(void) = (
  next:var(int).
  
  setmypriority(PRI_TIMEADV);
  forever(
    yield;
    promote_waits;
    next:=nexttime(perpetual,cosimulation_activated);
    if (next=-1) then (
       if (cosimulation_activated) then cosimulation_cmd("end",void);
       exit(0)
    );
    if (cosimulation_activated) then cosimulation_cmd("timestep",void);
    now:=next;
    update_export_var("time")
  )
).

wait_for(delay:val(int)) : expr(void) = (
    target_time : var(int).
    target_time:=now+delay;
    regtime(mytid,target_time);
    setmypriority(PRI_SUSP);
    yield
).

activate_cosimulation(str:val(string)) : expr(void) = (
    printstr("activating cosimulation...\n");
    cosimulation_cmd("start "@str,void);
    cosimulation_activated:=true;
    perpetual:=true;
    printstr("cosimulation activated.\n")
).


adv_tid:var(int).
          
now:=0;
perpetual:=false;
cosimulation_activated:=false;
export_var(now,"time");
adv_tid:=spawn("advance_time" is advance_time,0)
