#!/bin/sh
exec perl -w -x $0 ${1+"$@"}
    if 0;

#!perl

foreach $i ("ctrl-pre.icode","ctrl-pre-g.icode",
            "ctrl-pre-p.icode","ctrl-pre-pg.icode")
{
    $debug=($i=~m/g\.icode/);
    $profile=($i=~m/pre-p/);

    open OUTF,">$i";

    print OUTF "
# $i
# Automatically generated by ctrl-pre.pl - do not edit

ENTRY_ctrl-pre
	SETSYM PC EXIT_ctrl-pre

####################################################
# (((S1:expr(void)) `;` (S2:expr(T:type))) : expr(T)).

EXTERN F__;_		# sequence
	POP PS T1	# S1's CX
	POP PS T2	# S1's PC
	POP PS T7	# T (discarded)
	SETSYM T5 R__;_
	PUSH RAS T5
	SETR CXP T1
	SETR PC T2
R__;_
";
    if ($debug)
    {
	print OUTF "	STEPPOINT
";
    }
    print OUTF "
	POP PS CXP	# S2's CX
	POP PS PC	# S2's PC

####################################################
# ((if (c:val(bool)) then (e1:expr(T:type)) else (e2:expr(T))) : expr(T)).

EXTERN F_if_then_else_	# conditional
	POP PS T1	# c
";
    if ($debug)
    {
	print OUTF "	STEPPOINT
";
    }
    print OUTF "
	SETSYMNZ T1 PC X_if_true
			# false branch
	POP PS T1	# T (discarded)
	POP PS T1	# e1's CX (discarded)
	POP PS T1	# e1's PC (discarded)
	POP PS CXP
	POP PS PC
X_if_true		# true branch
	POP PS T1	# T (discarded)
	POP PS T1	# e1's CX
	POP PS T2	# e1's PC
	POP PS T3	# e2's CX (discarded)
	POP PS T3	# e2's PC (discarded)
	SETR CXP T1
	SETR PC T2

####################################################
# ((if (c:val(bool)) then (e1:expr(void))) : expr(void)).

EXTERN F_if_then_		# conditional
	POP PS T1	# c
	SETSYMNZ T1 PC X_if_then_
			# false branch
	POP PS T1	# e1's CX (discarded)
	POP PS T1	# e1's PC (discarded)
	POP RAS PC
X_if_then_		# true branch
	POP PS CXP	# e1's CX
	POP PS PC	# e1's PC

####################################################
# ((while (c:expr(bool)) do (S:expr(void))) : expr(void)).

EXTERN F_while_do_	# loop
	NOP
A_while_do_
	POP PS CXP	# c's CX
	POP PS T1	# c's PC
	PUSH PS T1
	PUSH PS CXP
	SETSYM T2 R_while_do_
	PUSH RAS T2
	SETR PC T1	# evaluate c
R_while_do_
	POP PS T1	# value of c
	SETSYMNZ T1 PC B_while_do_
			# false branch
	POP PS T1	# c's CX (discarded)
	POP PS T1	# c's PC (discarded)
	POP PS T1	# S's CX (discarded)
	POP PS T1	# S's PC (discarded)
	POP RAS PC	# return
B_while_do_		# true branch
	POP PS T1	# c's CX
	POP PS T2	# c's PC
	POP PS CXP	# S's CX
	POP PS T3	# S's PC
	PUSH PS T3
	PUSH PS CXP
	PUSH PS T2
	PUSH PS T1
	SETSYM T1 L_while_do_
	PUSH RAS T1
";
    if ($debug)
    {
	print OUTF "	STEPPOINT
";
    }
    print OUTF "
	SETR PC T3	# evaluate S

L_while_do_
";
    if ($profile)
    {
	print OUTF "	POP PTIME T1
	PUSH PTIME T1
	GETTIME T2
	SETR T3 T2
	SUB T2 TIME
	SETR TIME T3
	LOAD T1 T4
	ADD T4 T2
	STORE T1 T4
";
    }
    print OUTF "
	SETSYM PC A_while_do_


####################################################
# (spawn(e:expr(void),fpnum:val(int)):expr(int)).

EXTERN F_spawn		# spawn new thread and return tid
	POP PS T1	# e's CX
	POP PS T2	# e's PC
	POP PS T3	# fpnum
";
    if ($profile) {
	print OUTF "	POP PTIME T4
	PUSH PTIME T4
";
    }
print OUTF "	FORK T5
	SETSYMNZ T5 PC X_spawn
			# child thread
";
    if ($profile) {
	print OUTF "	PUSH PTIME T4
	SETN TIME 0
";
    }
print OUTF "	SETR FPNUM T3
	SETR CXP T1
	SETSYM T6 R_spawn
	PUSH RAS T6
	SETR PC T2
R_spawn
";
    if ($profile) {
	print OUTF "	POP PTIME T4
	LOAD T4 T1
	GETTIME T2
	ADD T1 T2
	SUB T1 TIME
	STORE T4 T1
";
    }
print OUTF "	SETSYM_D T7 STRCR_endofthread
	PUSH PS T7
	BUILTIN tcl_cmd_noerr
	DIE
X_spawn			# parent thread
# mod PAR to replace int2str with i2s
	SETSYM_D T8 STRCR_i2sdefaultcharset
	PUSH PS T8
	SETN T8 10
	PUSH PS T8
# mod PAR _additions_ end
	PUSH PS T5
	BUILTIN i2s
# mod PAR ends
	SETSYM_D T7 STRCR_newthread
	PUSH PS T7
	SETN T8 3
	PUSH PS T8
	BUILTIN stringop # strcat
	BUILTIN tcl_cmd_noerr
	PUSH PS T5
	POP RAS PC

####################################################
# (running(tid:val(int)):expr(bool)).

EXTERN F_running	# is thread still running?
	POP PS T1	# tid
	RUNCHECK T1 T2
	PUSH PS T2
	POP RAS PC

####################################################
# mytid:expr(int).

EXTERN F_mytid		# TID of this thread
	PUSH PS TID
	POP RAS PC

####################################################
# (yield:expr(void)).

EXTERN F_yield		# yield control
	YIELD
	# DEBUG \"TID %reg\\n\" TID
	POP RAS PC

####################################################
# setmypriority(pri:val(int)):expr(void).

EXTERN F_setmypriority	# set priority of current thread
	POP PS T1	# pri
	SETMYPRI T1
	POP RAS PC

####################################################
# setpriority(tid:val(int),pri:val(int)):expr(void).

EXTERN F_setpriority	# set priority of a thread
	POP PS T2	# tid
	POP PS T1	# pri
	SETPRI T2 T1
	POP RAS PC

####################################################
# (forparnum:expr(int)).

EXTERN F_forparnum	# forpar itteration number
	PUSH PS FPNUM
	POP RAS PC

####################################################
# promote_waits:expr(void).

EXTERN F_promote_waits	# promote threads in PRI_DEMWAIT to PRI_WAIT
	BUILTIN promote_waits
	POP RAS PC

####################################################
# fatal(msg:val(string)):expr(void).

EXTERN F_fatal			# report error and exit
	BUILTIN fatal

####################################################
# warning(msg:val(string)):expr(void).

EXTERN F_warning			# report error and don't exit
	BUILTIN warning
	POP RAS PC

####################################################
# lardpos(void):expr(string).

EXTERN F_lardpos
	BUILTIN lardpos
	POP RAS PC

####################################################
# atexit(e:expr(void)):expr(void).

G_atexit
	NOP
	NOP

EXTERN F_atexit			# record a function to be called at exit
	POP PS T1		# e's CX
	POP PS T2		# e's PC
	SETSYM_D T3 G_atexit
	STORE T3 T1
	INC4 T3
	STORE T3 T2
	POP RAS PC


####################################################
# (exit(x:val(int)):expr(void)).

EXTERN F_exit		# terminate program
	SETSYM_D T3 G_atexit
	LOAD T3 T1	# atexit function's CX
	INC4 T3
	LOAD T3 T2	# atexit function's PC
	SETSYM T4 R_exit
	PUSH RAS T4
	SETR CXP T1
	SETR PC T2
R_exit
	END


####################################################
# strings


STRCR_endofthread
	EQN 1
	EQN 0
STR_endofthread
	EQS \"endofthread\"

STRCR_newthread
	EQN 1
	EQN 0
STR_newthread
	EQS \"newthread \"

STRCR_i2sdefaultcharset
	EQN 1
	EQN 0
STR_i2sdefaultcharset
	EQS \"_-0123456789\"

EXIT_ctrl-pre
	SETSYM_D T1 STRCR_endofthread
	INC4 T1
	SETSYM_D T2 STR_endofthread
	STORE T1 T2

	SETSYM_D T1 STRCR_newthread
	INC4 T1
	SETSYM_D T2 STR_newthread
	STORE T1 T2

	SETSYM_D T1 STRCR_i2sdefaultcharset
	INC4 T1
	SETSYM_D T2 STR_i2sdefaultcharset
	STORE T1 T2

";

}


