/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: i2s.l,v 1.2 2000/07/19 11:20:38 bardslea Exp $

    
    LARD Strings-integer conversion package

	11 Jun 1999, AMULET Group
*/

/* Do b2s too */

b2s (value:val(bool)) : expr(string) = (
	if (value) then "true" else "false"
).

i2s : overloaded.
/* with 3 arguments */
i2s (value:val(int), radix:val(int), characterset:val(string)) : expr(string).

/* with just 2 arguments */
i2s (i:val(int), radix:val(int)) : expr(string) = (
  i2s(i,radix,"_-0123456789abcdefghijklmnopgrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ")
).

/* with only 1 argument */
i2s (i:val(int)) : expr(string) = (
  i2s(i,-10,"_-0123456789")
).

/* backward compatability */
/* old i2hex() produced 8 digits always */
i2hex (i:val(int)) : expr(string) = (
  formatdata("%08X",i)
).


s2i : overloaded.
/* with 2 arguments */
s2i (str:val(string), radix:val(int)) : expr(int) = (
  arg:var(record(r::int, i::int)).
  (arg->r := radix);
  sink(parsedata("%r%i", str, arg));
  arg->i
).

/* with only 1 argument */
s2i (str:val(string)) : expr(int) = (
  value:var(int).
  sink(parsedata("%i", str, value));
  value  
).

/* Alternative concatenations */

(i:val(int)) @ (s:val(string)) : expr(string) = ( i2s (i) @ s ).
(s:val(string)) @ (i:val(int)) : expr(string) = ( s @ i2s (i) ).


null
