#!/bin/sh
exec perl -x $0 ${1+"$@"}
    if 0;

#!perl

do 'includes.pl';


print "
# types.icode.pre
# This file is automatically generated by types.icode.pl.  Do not edit!

ENTRY_types-pre
	SETSYM PC EXIT_types-pre

####################################################
# ref(T:type) : type.

EXTERN T_ref
	POP PS T1
	SETN T1 4
	PUSH PS T1
	POP RAS PC

####################################################
# mkref(v:var(T:type)):val(ref(T)).

EXTERN V_mkref
	POP PS T1
	POP RAS PC

####################################################
# deref(p:val(ref(T:type))):var(T).

EXTERN V_deref
	POP PS T1
	POP RAS PC

####################################################
# (((T:type)`^`(n:val(int))) : type).

EXTERN T__^_		# vector type
	POP PS T1	# T
	POP PS T2	# n
	MUL T1 T2
	PUSH PS T1
	POP RAS PC

####################################################
# (((V:val((T:type)^(n:val(int))))[(i:val(int))]) : val(T)).

# This could be improved using POPFORGET except that we don't know i
# until after all of V has been popped.

EXTERN V__[_]_2		# val array indexing
	POP PS T1	# T
	POP PS T2	# n
	SETR T3 T1
	MUL T3 T2	# size of V
	ALLOC T3 T4
	SETR T7 T3
	SETR T6 T4
L_val_index_1
	POP PS T5	# V
	STORE T6 T5
	INC4 T6
	DEC4 T7
	SETSYMNZ T7 PC L_val_index_1
	
	POP PS T6	# i
	CMPGTEQ T7 T6 T2
	SETSYMNZ T7 PC E__[_]_3
	SETN T8 0
	CMPLT T7 T6 T8
	SETSYMNZ T7 PC E__[_]_4

	INC T6
	MUL T6 T1
	ADD T6 T4
	DEC4 T6
	SETR T7 T1
L_val_index_2
	LOAD T6 T5
	PUSH PS T5
	DEC4 T6
	DEC4 T7
	SETSYMNZ T7 PC L_val_index_2

	FREE T4
	POP RAS PC

E__[_]_3			# index in T6, size in T2
	SETSYM_D T1 STRCR_newline
	PUSH PS T1
	PUSH PS T2
	BUILTIN int2str
	SETN T3 3
	PUSH PS T3
	BUILTIN stringop # strcat
	SETSYM_D T1 STRCR_arraysize
	PUSH PS T1
	PUSH PS T3
	BUILTIN stringop # strcat
	PUSH PS T6
	BUILTIN int2str
	PUSH PS T3
	BUILTIN stringop # strcat
	SETSYM_D T1 STRCR_outofrange
	PUSH PS T1
	PUSH PS T3
	BUILTIN stringop # strcat
	BUILTIN fatal

E__[_]_4			# index in T6
	SETSYM_D T1 STRCR_newline
	PUSH PS T1
	PUSH PS T6
	BUILTIN int2str
	SETN T3 3
	PUSH PS T3
	BUILTIN stringop # strcat
	SETSYM_D T1 STRCR_outofrange
	PUSH PS T1
	PUSH PS T3
	BUILTIN stringop # strcat
	BUILTIN fatal

####################################################
# (((V:var((T:type)^(n:val(int))))[(i:val(int))]) : var(T)).

EXTERN V__[_]_3		# var array indexing
	POP PS T1	# T
	POP PS T2	# n
	POP PS T3	# V
	POP PS T4	# i
	CMPGTEQ T5 T4 T2
	SETSYMNZ T5 PC E__[_]_1
	SETN T6 0
	CMPLT T5 T4 T6
	SETSYMNZ T5 PC E__[_]_2
	MUL T1 T4
	ADD T3 T1
	PUSH PS T3
	POP RAS PC

E__[_]_1
	SETR T6 T4
	SETSYM PC E__[_]_3

E__[_]_2
	SETR T6 T4
	SETSYM PC E__[_]_4

####################################################
# (((r:val(refarray(T:type,n:val(int)))))[(i:val(int))]) : var(T)).

EXTERN V__[_]_4		# val array indexing
	POP PS T1	# T
	POP PS T2	# n
	SETN T3 4
	MUL T3 T2	# size of r
	ALLOC T3 T4
	SETR T7 T3
	SETR T6 T4
L_val_index_3
	POP PS T5	# r
	STORE T6 T5
	INC4 T6
	DEC4 T7
	SETSYMNZ T7 PC L_val_index_3
	
	POP PS T6	# i
	CMPGTEQ T7 T6 T2
	SETSYMNZ T7 PC E__[_]_3
	SETN T8 0
	CMPLT T7 T6 T8
	SETSYMNZ T7 PC E__[_]_4

	SETN T3 4
	MUL T6 T3
	ADD T6 T4
	LOAD T6 T7
	PUSH PS T7
	FREE T4
	POP RAS PC

####################################################
# family of vector constructor functions such as
# (( [ (e1:val(T:type)) , (e2:val(T)) , (e3:val(T)) ] ) : expr(T^3)).
# (( < (e1:val(ref(T:type))) ; (e2:val(ref(T))) , (e3:val(ref(T))) > ) : expr(refarray(T,3))).

";

foreach $i (0..$max_veccons)
{
    print "EXTERN F_[_";
    for (1..$i)
    {
	print ",_";
    }
    print "]\n";
    print "EXTERN F_<_";
    for (1..$i)
    {
	print ";_";
    }
    print ">\n";
}

print "
	POP PS T1	# T (discarded)
	POP RAS PC	# leave other args on stack to form result

";

foreach $i (1..$max_record_fields)
{
    print "
####################################################
# record$i(T1:type";
	
    foreach $j (2..$i)
    {
	print ",T$j:type";
    }

    print "):type.

EXTERN T_record$i
\tPOP PS T1
";

    for (2..$i)
    {
	print "\tPOP PS T2
\tADD T1 T2
";
    }

    print "\tPUSH PS T1
\tPOP RAS PC
";

}


$ip=1;

foreach $ifwd (1..$max_record_fields)
{
    $i=$max_record_fields+1-$ifwd;
    $ip=$ip+1;
    print "
####################################################
# val_index_record(i:val(int),R:val(record$i(T1:type";

    foreach $j (2..$i)
    {
	print ",T$j:type";
    }

    print ")),TR:type):expr(TR)).

EXTERN F_val_index_record_$ip
	SETN T1 $i
	SETSYM PC F_val_index_record_generic
";
}

print "
F_val_index_record_generic
				# T1 is number of fields
	POP PS T2		# i
				# find size of stuff to pop before
				# required record
	SETN T3 0
	SETR T5 T2
	SETSYMNZ T5 PC L_val_index_record_generic_1
	SETSYM PC X_val_index_record_generic_1
L_val_index_record_generic_1
	POP PS T4		# size of next field
	ADD T3 T4
	DEC T5
	SETSYMNZ T5 PC L_val_index_record_generic_1
X_val_index_record_generic_1
				# T3 is stuff to pop before
	POP PS T6		# find size of required record in T6
				# find size of stuff to pop after
	SETN T7 0
	SUB T1 T2
	DEC T1
	SETSYMNZ T1 PC L_val_index_record_generic_2
	SETSYM PC X_val_index_record_generic_2
L_val_index_record_generic_2
	POP PS T4		# size of next field
	ADD T7 T4
	DEC T1
	SETSYMNZ T1 PC L_val_index_record_generic_2
X_val_index_record_generic_2
				# T7 is stuff to pop after
				# pop before stuff
	POPFORGET PS T3
				# pop required record
	ALLOC T6 T2		# space for copy of required field
	SETR T8 T6
	SETR T3 T2
	SETSYMNZ T8 PC L_val_index_record_generic_4
	SETSYM PC X_val_index_record_generic_4
L_val_index_record_generic_4
	POP PS T1		# R
	STORE T3 T1
	INC4 T3
	DEC4 T8
	SETSYMNZ T8 PC L_val_index_record_generic_4
X_val_index_record_generic_4
				# pop after stuff
	POPFORGET PS T7
	POP PS T1		# TR
	CMPNEQ T8 T1 T6
	SETSYMNZ T8 PC ERR_val_index_record_generic
	SETR T8 T6
	SETR T3 T2
	ADD T3 T6
	SETSYMNZ T8 PC L_val_index_record_generic_6
	SETSYM PC X_val_index_record_generic_6
L_val_index_record_generic_6
	DEC4 T3
	LOAD T3 T1
	PUSH PS T1		# result
	DEC4 T8
	SETSYMNZ T8 PC L_val_index_record_generic_6
X_val_index_record_generic_6
	FREE T2
	POP RAS PC

ERR_val_index_record_generic
	SETSYM_D T1 STRCR_fieldsize
	PUSH PS T1
	BUILTIN fatal
";

$ip=1;

foreach $ifwd (1..$max_record_fields)
{
    $i=$max_record_fields+1-$ifwd;
    $ip=$ip+1;
    print "
####################################################
# var_index_record(i:val(int),R:var(record$i(T1:type";

    foreach $j (2..$i)
    {
	print ",T$j:type";
    }

    print ")),TR:type):var(TR)).

EXTERN V_var_index_record_$ip
	SETN T1 $i
	SETSYM PC VV_var_index_record_generic
";
}

print "

VV_var_index_record_generic
				# T1 is number of fields
	POP PS T2		# i
				# find displacement to start of required field
	SETR T5 T2
	SETN T3 0
	SETSYMNZ T5 PC L_var_index_record_generic_1
	SETSYM PC X_var_index_record_generic_1
L_var_index_record_generic_1
	POP PS T4		# next type
	ADD T3 T4
	DEC T5
	SETSYMNZ T5 PC L_var_index_record_generic_1
X_var_index_record_generic_1
				# displacement is in T3
	SUB T1 T2
	SETN T6 0
	SETSYMNZ T1 PC L_var_index_record_generic_2
	SETSYM PC X_var_index_record_generic_2
L_var_index_record_generic_2
	POP PS T4		# next type (discarded)
	DEC T1
	SETSYMNZ T1 PC L_var_index_record_generic_2
X_var_index_record_generic_2
	POP PS T7		# R
	POP PS T1		# TR (discarded)
	ADD T7 T3		# add displacement to variable address
	PUSH PS T7
	POP RAS PC

";

foreach $i (1..$max_reccons)
{
    print "
####################################################
# { (e1:val(T1:type)) ";
    foreach $j (2..$i)
    {
	print " , (e$j:val(T$j:type))";
    }
    print " } : expr(record(T1";
    foreach $j (2..$i)
    {
	print ",T$j";
    }
    print ")).

EXTERN F_{_";
    foreach $j (2..$i)
    {
	print ",_";
    }
    print "}
	SETN T1 $i
	SETSYM PC F_reccons_generic
";
}

print "
F_reccons_generic
				# T1 is #fields
	SETN T2 8
	MUL T2 T1
	ALLOC T2 T3		# T3 is space for field sizes and field
				# storage pointers
	SETR T4 T1		# T4 is count of fields as they are popped
	SETR T5 T3		# Pointer into T3 area
	SETSYMNZ T4 PC L_rcg_1
	SETSYM PC X_rcg_1
L_rcg_1
	POP PS T6		# Size of field
	STORE T5 T6		# Store size of field
	INC4 T5
	ALLOC T6 T7		# T7 is space for this field
	STORE T5 T7		# Store pointer to space
	INC4 T5
	SETSYMNZ T6 PC L_rcg_2
	SETSYM PC X_rcg_2
L_rcg_2
	POP PS T8		# Part of the field
	STORE T7 T8		# Store it
	INC4 T7
	DEC4 T6
	SETSYMNZ T6 PC L_rcg_2
X_rcg_2
	DEC T4
	SETSYMNZ T4 PC L_rcg_1
X_rcg_1
	SETR T4 T1		# T4 is count of fields as they are pushed
	SETSYMNZ T4 PC L_rcg_3
	SETSYM PC X_rcg_3
L_rcg_3
	DEC4 T5
	LOAD T5 T7		# Pointer to space for this field
	DEC4 T5
	LOAD T5 T6		# Size of field
	ADD T7 T6
	SETSYMNZ T6 PC L_rcg_4
	SETSYM PC X_rcg_4
L_rcg_4
	DEC4 T7
	LOAD T7 T8		# Part of the field
	PUSH PS T8		# Push it
	DEC4 T6
	SETSYMNZ T6 PC L_rcg_4
X_rcg_4
	FREE T7
	DEC T4
	SETSYMNZ T4 PC L_rcg_3
X_rcg_3
	FREE T5
	POP RAS PC
";


print "

####################################################
# strings

STRCR_outofrange
	EQN 1
	EQN 0
STR_outofrange
	EQS \"Array index out of range: index=\"

STRCR_arraysize
	EQN 1
	EQN 0
STR_arraysize
	EQS \", array size=\"

STRCR_newline
	EQN 1
	EQN 0
STR_newline
	EQS \"\\n\"

STRCR_fieldsize
	EQN 1
	EQN 0
STR_fieldsize
	EQS \"Record field size discrepency\\n\"

EXIT_types-pre
	SETSYM_D T1 STRCR_outofrange
	INC4 T1
	SETSYM_D T2 STR_outofrange
	STORE T1 T2

	SETSYM_D T1 STRCR_arraysize
	INC4 T1
	SETSYM_D T2 STR_arraysize
	STORE T1 T2

	SETSYM_D T1 STRCR_newline
	INC4 T1
	SETSYM_D T2 STR_newline
	STORE T1 T2

	SETSYM_D T1 STRCR_fieldsize
	INC4 T1
	SETSYM_D T2 STR_fieldsize
	STORE T1 T2



";
