#!/bin/sh
exec perl -x $0 ${1+"$@"}
    if 0;

#!perl

do 'includes.pl';

print "
/* LARD Standard Library : types.l */
/* This file is automatically generated by types.l.pl.  Do not Edit! */

/* This file declares the structured types and functions that
   operate on them. */

/* Vectors */

/* the type*/

_^_ : infix(160,left).
(T:type) ^ (n:val(int)) : type.

/* Refs, Refarrays */

ref (T:type) : type .

refarray (T:type, n:val(int)) : type = (ref(T) ^ n) .

mkref (v : var(T:type)) : val(ref(T)) .
deref (r : val(ref(T:type))) : var(T) .

/* Vector indexing functions */

_[_] : infix(190,none).
`_[_]` : overloaded.

(V:val((T:type)^(n:val(int)))) [ (i:val(int)) ] : val(T).

(V:var((T:type)^(n:val(int)))) [ (i:val(int)) ] : var(T).

(V:val(refarray(T:type,n:val(int)))) [ (i:val(int)) ] : var(T).

/* constructor functions */

";

foreach $i (1..$max_veccons)
{
    print "[_";
    for (2..$i)
    {
	print ",_";
    }
    print "] : infix(90,none).
[ (e1:val(T:type)) ";
    foreach $j (2..$i)
    {
       print " , (e$j:val(T))";
    }
    print " ] : expr(T^$i).

";
    print "<_";
    for (2..$i)
    {
	print ";_";
    }
    print "> : infix(90,none).
< (e1:var(T:type)) ";
    foreach $j (2..$i)
    {
       print " ; (e$j:var(T))";
    }
    print " > : expr(refarray(T,$i)).

";
}

print "
/* New version of Records */

_->_ : infix(190,left).
_::_ : infix(20,none).

/* Types */

record : varargs.
";

foreach $i (1..$max_record_fields)
{
    print "record$i(T1:type";
    foreach $j (2..$i)
    {
	print ",T$j:type";
    }
    print "):type.
";
}

print "
/* Value indexing functions */

val_index_record : overloaded.
";

foreach $ifwd (1..$max_record_fields)
{
    $i=$max_record_fields+1-$ifwd;
    print "val_index_record(i:val(int),R:val(record$i(T1:type";
    foreach $j (2..$i)
    {
	print ",T$j:type";
    }
    print ")),TR:type):expr(TR).
";
}

print "
/* Variable indexing functions */

var_index_record : overloaded.
";

foreach $ifwd (1..$max_record_fields)
{
    $i=$max_record_fields+1-$ifwd;
    print "var_index_record(i:val(int),R:var(record$i(T1:type";
    foreach $j (2..$i)
    {
	print ",T$j:type";
    }
    print ")),TR:type):var(TR).
";
}

print "
/* Record constructor functions */

";

foreach $i (1..$max_reccons)
{
    print "{_";
    for (2..$i)
    {
	print ",_";
    }
    print "} : infix(90,none).
{ (e1:val(T1:type)) ";
    foreach $j (2..$i)
    {
        print " , (e$j:val(T$j:type))";
    }
    print " } : expr(record(T1";
    foreach $j (2..$i)
    {
        print ",T$j";
    }
    print ")).

";
}




print "

/* Ranges */

range(T:type) : type = record(
  left_index :: T,
  right_index :: T
).

_to_ : infix(60,left).
(l:val(T:type)) to (r:val(T)) : expr(range(T)) = (
  cast(range(T),{l,r})
).

/* Main program */

null

";
