/*
    The Language for Asynchronous Research and Development -- LARD
    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Id: main.c,v 1.3 2000/10/02 01:49:06 bardslea Exp $


	Linker top level

	11 Jun 1999, AMULET Group
*/

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>

#include <alloc.h>
#include <error.h>
#include <simple.h>

#include <lard_link.h>

char * infilename = "";
int line_num = 0;
char * input_buffer = "";

char * outfn;

void parse_arguments_1(int argc, char * argv[])
{
  int i;
  
  for(i=1;i<argc;i++)
  {
    if (strcmp(argv[i],"-o")==0)
    {
      i++;
      outfn=argv[i];
    } else if (strcmp(argv[i],"-v")==0)
    {
      lard_link_verbose=TRUE;
    } else if (strcmp(argv[i],"-norelocs")==0)
    {
      lard_norelocs=TRUE;
    } else if (strcmp(argv[i],"-istrip")==0)
    {
      lard_istrip=TRUE;
    } else if (strcmp(argv[i],"-estrip")==0)
    {
      lard_estrip=TRUE;
    } else
    {
          /* do nothing */
    }
  }
}

void parse_arguments_2(int argc, char * argv[])
{
  int i;
  
  for(i=1;i<argc;i++)
  {
    if (strcmp(argv[i],"-o")==0)
    {
      i++;
    } else if (strcmp(argv[i],"-v")==0)
    {
          /* do nothing */
    } else if (strcmp(argv[i],"-norelocs")==0)
    {
          /* do nothing */
    } else if (strcmp(argv[i],"-istrip")==0)
    {
          /* do nothing */
    } else if (strcmp(argv[i],"-estrip")==0)
    {
          /* do nothing */
    } else
    {
      lard_link_load_file(argv[i]);
    }
  }
}


int main ( int argc, char * argv[] )
{
  outfn=NULL;
  
  parse_arguments_1(argc,argv);

  if (!outfn)
  {
    fatal("No output filename specified\n");
  }
  
  parse_arguments_2(argc,argv);

  llink();

  if (lard_norelocs && lard_relocsectsize>0)
  {
    fatal("Unresolved relocations found\n");
  }

  lard_link_save_file(outfn);

  return 0;
}

