#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: config.tcl,v 1.1.1.1 1999/07/15 18:47:51 bardslea Exp $
#
#
#   Config module save configuration
#
#	11 Jun 1999, AMULET Group


proc config_save {filename} {
    global config_save_list
    global bci_filename

    set f [open $filename w]
    puts $f "\# li configuration file for \"$bci_filename\""
    puts $f "\# written [clock format [clock seconds]]"
    puts $f ""
    foreach p $config_save_list {
	lassign $p shortname longname
	global config_save_$shortname
	set savethis [set config_save_$shortname]
	puts $f "\# $longname"
	if {$savethis} {
	    config_save_go_$shortname $f
	} else {
	    puts $f "\# not saved"
	}
	puts $f ""
    }
    close $f
}


# Utilities for saving configuration

proc config_save_var {f varname} {
    global $varname

    set value [set $varname]
    puts $f "set $varname {$value}"
}

proc config_save_array {f arrname} {
    global $arrname

    set arrval [array get $arrname]
    puts $f "array set $arrname {$arrval}"
}



# Save config status (!)

lappend config_save_list \
    {{config} {Save which aspects of configuration are saved}}

proc config_save_go_config {f} {
    global config_save_list

    foreach p $config_save_list {
	lassign $p shortname longname
	config_save_var $f config_save_$shortname
    }
}
