#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: li.tcl,v 1.1.1.1 1999/07/15 18:47:51 bardslea Exp $
#
#
#   li module
#   code to load other modules
#   li_load and li_load_path are defined in init.tcl
#
#	11 Jun 1999, AMULET Group

set li_modules {li}

proc li_require {module} {
    global li_modules

    if {[lsearch -exact $li_modules $module]!=-1} {
	return
    } else {
	lappend li_modules $module
	li_load $module
    }
}

proc li_startup_module {module} {
    global li_startup

    if {!$li_startup} {
	error "$module can only be loaded at startup"
    }
}

set li_startup 1

proc quit {} {

    destroy .
}


# save active modules

lappend config_save_list {{modules} {Save active modules}}

proc config_save_go_modules {f} {
    global li_modules

    foreach m $li_modules {
	puts $f "li_require $m"
    }
}

