#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: msg.tcl,v 1.2 2000/03/24 17:06:42 bardslea Exp $
#
#
#   Log messages
#
#	11 Jun 1999, AMULET Group

li_require tview
li_require selector
li_require threads

global selector_toplevel
global cands_menubar
global main_menubar 
global main_notebook

menubutton $cands_menubar.messages -text "Messages" \
    -menu $cands_menubar.messages.menu -underline 0
pack $cands_menubar.messages -side left

menu $cands_menubar.messages.menu
$cands_menubar.messages.menu add cascade \
    -label "Default Action" -menu $cands_menubar.messages.menu.defaction \
    -underline 0
$cands_menubar.messages.menu add cascade \
    -label "Time View Defaults" -menu $cands_menubar.messages.menu.tvdefs \
    -underline 0


menu $cands_menubar.messages.menu.defaction
$cands_menubar.messages.menu.defaction add radiobutton \
    -label "Ignored" -variable msg_default_action -underline 0
$cands_menubar.messages.menu.defaction add radiobutton \
    -label "Time View" -variable msg_default_action -underline 0
$cands_menubar.messages.menu.defaction add radiobutton \
    -label "Alert" -variable msg_default_action -underline 0
$cands_menubar.messages.menu.defaction add radiobutton \
    -label "Window" -variable msg_default_action -underline 0
$cands_menubar.messages.menu.defaction add radiobutton \
    -label "Stdout" -variable msg_default_action -underline 0

menu $cands_menubar.messages.menu.tvdefs
$cands_menubar.messages.menu.tvdefs add checkbutton \
    -label "Show databox" -variable msg_default_databox \
    -underline 11
$cands_menubar.messages.menu.tvdefs add checkbutton \
    -label "Show blobs" -variable msg_default_blob \
    -underline 5

global msg_window
set msg_window "."

#toplevel $msgwin
#wm title $msgwin "Messages"
#wm iconname $msgwin "Messages"

set msgwin ".msgwin"
frame $msgwin
pack $msgwin
set msgwin [$main_notebook insert end msgwin -text "Messages"]
#$main_notebook raise msgwin
# Make me a predictably named tview_toplevel
frame $msgwin.msgwin
set msgwin $msgwin.msgwin
pack $msgwin -expand true -fill both

frame $msgwin.menubar

menubutton $msgwin.menubar.window -text "Page" \
    -menu $msgwin.menubar.window.menu -underline 0
pack $msgwin.menubar.window -side left
menu $msgwin.menubar.window.menu
$msgwin.menubar.window.menu add command -label "Close" \
    -command "set msgwin_open 0" -underline 0

text $msgwin.header
$msgwin.header insert end \
    "\ttime" "time" "\tblock" "block" "\tmessage" "message"

text $msgwin.text -yscrollcommand "$msgwin.yscr set" \
    -xscrollcommand "$msgwin.xscr set"

scrollbar $msgwin.yscr -command "$msgwin.text yview"
scrollbar $msgwin.xscr -orient horiz -command "msgwin_xscr"

grid $msgwin.menubar -row 0 -column 0 -columnspan 2 -sticky ew
grid $msgwin.header -row 1 -column 0 -sticky ew
grid $msgwin.text -row 2 -column 0 -sticky nsew
grid $msgwin.yscr -row 2 -column 1 -sticky ns
grid $msgwin.xscr -row 3 -column 0 -sticky ew

grid columnconfigure $msgwin 0 -weight 1
grid columnconfigure $msgwin 1 -weight 0

grid rowconfigure $msgwin 0 -weight 0
grid rowconfigure $msgwin 1 -weight 0
grid rowconfigure $msgwin 2 -weight 1
grid rowconfigure $msgwin 3 -weight 0

proc msgwin_xscr {args} {

    # This doesn't work because xview uses fractions and the header
    # and text are not the same width.  Bummer.
    eval $msgwin.header xview $args
    eval $msgwin.text xview $args
}

proc msgwin_open_changed {name1 name2 op} {
    global msgwin_open
    global msg_window
    global main_notebook

    if {$msgwin_open} {
	wm deiconify $msg_window
    } else {
#	wm withdraw $msg_window
	$main_notebook delete msgwin
    }
}

trace variable msgwin_open w msgwin_open_changed

set msgwin_open 1

$main_menubar.windows.menu add checkbutton -label "Messages" \
    -variable msgwin_open -underline 0

$main_menubar.session.menu.modules entryconfigure {Messages} \
    -state disabled


proc msg_selector_post_update {pathname} {
    global msg_action
	global selector_toplevel
    set tname [lrange $pathname 0 [expr [llength $pathname] -2]]

    menubutton $selector_toplevel.text.msgmenu$tname \
	-textvariable msg_action($tname) -menu $selector_toplevel.text.msgmenu$tname.menu \
	-relief raised
    menu $selector_toplevel.text.msgmenu$tname.menu
    $selector_toplevel.text.msgmenu$tname.menu add radiobutton \
	-variable msg_action($tname) -label "Ignored" -underline 0
    $selector_toplevel.text.msgmenu$tname.menu add radiobutton \
	-variable msg_action($tname) -label "Time View" -underline 0
    $selector_toplevel.text.msgmenu$tname.menu add radiobutton \
	-variable msg_action($tname) -label "Alert" -underline 0
    $selector_toplevel.text.msgmenu$tname.menu add radiobutton \
	-variable msg_action($tname) -label "Window" -underline 0
    $selector_toplevel.text.msgmenu$tname.menu add radiobutton \
	-variable msg_action($tname) -label "Stdout" -underline 0
    $selector_toplevel.text window create insert \
	-window $selector_toplevel.text.msgmenu$tname
}


append selector_post_update_hook {
	global selector_toplevel

    if {[lsearch -exact $attrlist msg] != -1} {
	msg_selector_post_update $pathname
    }
}


proc msg {s} {
    global msg_action
    global bci_current_thread
    global msg_default_action
    global msg_default_databox
    global msg_default_blob
    global threadnames
    global time
    global msg_tvids
    global msg_databox
    global msg_blob
    global bci_run_stop

    set tname $threadnames($bci_current_thread)

    if {[catch {set action $msg_action($tname)}]} {
	set msg_action($tname) $msg_default_action
	set msg_databox($tname) $msg_default_databox
	set msg_blob($tname) $msg_default_blob
	struct_add "msg" [concat $tname messages]
	set action $msg_default_action
    }

    if {$action=="Ignored"} {
	return
    } elseif {$action=="Time View"} {
	if {$msg_databox($tname)} {
	    tview_databox $msg_tvids($tname) $time $s
	}
	if {$msg_blob($tname)} {
	    blob $msg_tvids($tname) $time $s
	}
    } elseif {$action=="Alert"} {
	set text "Message from $tname at time $time:\n$s"
	set choice \
	    [tk_dialog .msgdialog "Message" $text "" 0 "Continue" "Stop"]
	if {$choice==1} {
	    set bci_run_stop 1
	}
    } elseif {$action=="Window"} {
	$msgwin.text insert end \
	    "\t$time" "time" "\t$tname" block \
	    "\t$s\n" message
	$msgwin.text yview -pickplace end
    } elseif {$action=="Stdout"} {
	stdio_outline "$s\n"
    }
}



set msg_default_action "Time View"
set msg_default_databox 0
set msg_default_blob 1


trace variable msg_action w msg_action_update


proc msg_action_update {name1 tname op} {
    global msg_action

    if {$msg_action($tname)=="Time View"} {
	msg_tview_add $tname
    } else {
	msg_tview_delete $tname
    }
}


proc msg_tview_add {tname} {
    global msg_tvids
    global tview_toplevel

    if {![catch {set msg_tvids($tname)}]} {
	return
    }
    set tvid [tview_new $tname]
    set msg_tvids($tname) $tvid
    $tview_toplevel.tracenames.$tvid.menu add command -label "Delete" \
	-command "set msg_action($tname) Ignored" -underline 0
    $tview_toplevel.tracenames.$tvid.menu add checkbutton -label "Show databox" \
	-variable msg_databox($tname) -underline 11
    $tview_toplevel.tracenames.$tvid.menu add checkbutton -label "Show blobs" \
	-variable msg_blob($tname) -underline 5
}


proc msg_tview_delete {tname} {
    global msg_tvids

    if {[catch {set msg_tvids($tname)}]} {
	return
    }
    tview_delete $msg_tvids($tname)
    unset msg_tvids($tname)
}


lappend config_save_list {{msg} {Save message configurations}}

proc config_save_go_msg {f} {
    global msg_action
    global msg_databox
    global msg_blob
    global msg_default_action
    global msg_default_databox
    global msg_default_blob
    
    puts $f "\# Save message configurations"
    set a [array get msg_action]
    puts $f "array set msg_action {$a}"
    set a [array get msg_databox]
    puts $f "array set msg_databox {$a}"
    set a [array get msg_blob]
    puts $f "array set msg_blob {$a}"
    puts $f "set msg_default_action {$msg_default_action}"
    puts $f "set msg_default_databox {$msg_default_databox}"
    puts $f "set msg_default_blob {$msg_default_blob}"
}

