#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: start.tcl,v 1.1.1.1 1999/07/15 18:47:52 bardslea Exp $
#
#
#   This file is loaded from init.tcl which is embedded in the C
#   The purpose of this code is to load the "automatic" modules and then
#   process the command line.
#
#	11 Jun 1999, AMULET Group

# Hide the main window as it is not used in the command line version
catch {wm withdraw .}

# Load module li
li_load li

# Load other automatic modules
set auto_modules {bci stdio}
foreach mod $auto_modules {
    li_require $mod
}


# Process the command line

set bci_filename [lindex $argv 1]

namespace eval ::lard namespace current
# if there is a -- on the command line, all subsequent arguments are for the lard
if {[lsearch -exact $argv --end] == -1} {
    set tcl_filenames [lrange $argv 2 end]
	set ::lard::arguments [list]
} else {
#    global lard_arguments
	set ::lard::arguments [lrange $argv [expr [lsearch -exact $argv --end] + 1] end]
	if {! [llength ::lard::arguments]} {
		[set ::lard::arguments [list]]
	}
    set tcl_filenames [lrange $argv 2 [expr [lsearch -exact $argv --end] - 1]]
}

if [cequal $bci_filename -] {
    set bci_filename {}
}

if {$bci_filename != {}} {
    if {[catch {bci_load $bci_filename} errmsg]} {
	puts stderr $errmsg
	exit 1
    }
}

while {$tcl_filenames != {}} {
    if {[catch {li_require [lvarpop tcl_filenames]} errmsg]} {
    	puts stderr $errmsg
    	# error $errmsg
    	exit 1
    }
}


# Load .lirc files

proc source_if_exists {fn} {
    if {[file exists $fn]} {
	if {[catch {uplevel \#0 source $fn} errmsg]} {
	    puts stderr $errmsg
	    exit 1
	}
    }
}

source_if_exists $env(HOME)/.lirc

source_if_exists .lirc

if {$bci_filename != {}} {
    source_if_exists $bci_basename.lirc
}


