#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: threads.tcl,v 1.3 2000/10/23 11:44:24 bardslea Exp $
#
#
#   Maintain information about threads
#
#	11 Jun 1999, AMULET Group

# These are called by "is"


li_require selector


proc pushblockname {name} {
    global threadnames
    global bci_current_thread

    lvarpush threadnames($bci_current_thread) $name len
    struct_add block $threadnames($bci_current_thread)
}


proc popblockname {} {
    global threadnames
    global bci_current_thread

    lvarpop threadnames($bci_current_thread) end
}


# This is called by spawn

proc newthread {tid} {
    global threadnames
    global bci_current_thread
    global threads_traced

    set threadnames($tid) $threadnames($bci_current_thread)
    set threads_traced($tid) $threads_traced($bci_current_thread)
}


proc endofthread {} {
    global threadnames
    global bci_current_thread
    global threads_traced

    unset threadnames($bci_current_thread)
    unset threads_traced($bci_current_thread)
}


# Initialisation of thread 1

set threadnames(1) "toplevel"
set threads_traced(1) 1



