#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: winconfig.tcl,v 1.2 2000/03/24 17:06:45 bardslea Exp $
#
#
#   Winconfig module
#   Windows interface to load and save configuration
#
#	11 Jun 1999, AMULET Group


li_require windows
li_require config

global main_menubar

$main_menubar.session.menu insert 0 command -label "Save configuration..." \
    -command winconfig_save -underline 0
$main_menubar.session.menu insert 1 command -label "Load configuration..." \
    -command winconfig_load -underline 0

if {$bci_filename!=""} {
    set winconfig_save_filename "$bci_basename.lirc"
    set winconfig_load_filename $winconfig_save_filename
} else {
    set winconfig_save_filename ""
    set winconfig_load_filename ""
}

proc winconfig_save {} {
    global config_save_list
    global winconfig_save_filename
    global winconfig_save_new_filename

    set winconfig_save_new_filename $winconfig_save_filename
    toplevel .savedialog
    wm title .savedialog "Save Configuration"
    foreach p $config_save_list {
	lassign $p shortname longname
	checkbutton .savedialog.$shortname -text $longname \
	    -variable config_save_$shortname
	pack .savedialog.$shortname -anchor w -side top
    }
    frame .savedialog.buttons
    button .savedialog.buttons.ok -text "OK..." -command winconfig_save_go
    pack .savedialog.buttons.ok -side left
    button .savedialog.buttons.cancel -text "Cancel" \
	-command "grab release .savedialog; destroy .savedialog"
    pack .savedialog.buttons.cancel
    pack .savedialog.buttons -side bottom
    grab .savedialog
}


proc winconfig_save_go {} {
    global winconfig_save_filename

    set new_filename \
	[tk_getSaveFile -initialfile $winconfig_save_filename \
	     -title "Save Configuration"]

    grab release .savedialog
    destroy .savedialog
    if {$new_filename==""} {
        return
    }
    set winconfig_save_filename $new_filename
    config_save $winconfig_save_filename
}
    

proc winconfig_load {} {
    global winconfig_load_filename
    global winconfig_load_new_filename

    set winconfig_load_new_filename [tk_getOpenFile \
					 -title "Load Configuration" \
					 -initialfile $winconfig_load_filename]
    if {$winconfig_load_new_filename==""} {
	return
    }
    set winconfig_load_filename $winconfig_load_new_filename
    uplevel \#0 source $winconfig_load_filename
}


