#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: winmodules.tcl,v 1.2 2000/03/24 17:06:46 bardslea Exp $
#
#
#   Winmodules module
#
#	11 Jun 1999, AMULET Group

# give a menu of modules

li_require windows

global main_menubar

$main_menubar.session.menu insert 0 cascade -label "Modules" \
    -menu $main_menubar.session.menu.modules -underline 0
menu $main_menubar.session.menu.modules

set modules { {channels Channels 0} \
		  {signals Signals -} \
		  {sourceview {Source View} 0} \
		  {simctrl {Simulation Controls} -} \
		  {bview {Block View} 0} \
		  {msg Messages 0} \
		  {tvec {Test Vectors} 0} \
		  {winpos {Window Positions} 0} \
		  {realtime Realtime 0} \
		  {tviewps {Time View Plot} 10} \
	      }

foreach p $modules {
	global main_menubar

    lassign $p modname desc ulchar
    if {$ulchar=="-"} {
	$main_menubar.session.menu.modules add command -label $desc \
	    -command "li_require $modname"
    } else {
	$main_menubar.session.menu.modules add command -label $desc \
	    -command "li_require $modname" -underline $ulchar
    }
}

trace variable li_modules w winmodules_update

proc winmodules_update {name1 name2 op} {
    global modules
    global li_modules
    global main_menubar

    foreach p $modules {
	lassign $p modname desc ulchar
	if {[lsearch -exact $li_modules $modname]!=-1} {
	    $main_menubar.session.menu.modules entryconfigure $desc -state disabled
	}
    }
}

winmodules_update a b c
