#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: winpos.tcl,v 1.1.1.1 1999/07/15 18:47:53 bardslea Exp $
#
#
#   Winpos module
#   Save window positions
#
#	11 Jun 1999, AMULET Group

namespace eval winpos {

    li_require windows
    li_require winutils
    li_require config

    lappend config_save_list {{winpos} {Save window positions}}

    proc config_save {f} {

	set allwinlist [winfo children .]
	set winlist {.}
	foreach win $allwinlist {
	    if {[winfo class $win]=="Toplevel"} {
		lappend winlist $win
	    }
	}

	foreach win $winlist {
	    set geom [wm geometry $win]
	    puts $f "wm geometry $win $geom"
	    regsub {^\.(.*)$} $win {::winutils::\1_open} openvar
	    if {![catch {set $openvar}]} {
		config_save_var $f $openvar
	    }
	}
    }
}

# hack until config does namespaces

proc config_save_go_winpos {f} {
    ::winpos::config_save $f
}
