#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: winstatus.tcl,v 1.2 2000/03/24 17:06:47 bardslea Exp $
#
#
#   Winstatus module
#   Provide a status line in the main window
#
#	11 Jun 1999, AMULET Group

li_require windows
li_require winstdio
li_require winbci

global main_menubar

frame .statusline

label .statusline.status -textvariable statusline_value
pack .statusline.status -side left

frame .statusline.time
label .statusline.time.label -text "Time:"
label .statusline.time.time -textvariable time
pack .statusline.time.label .statusline.time.time -side left
pack .statusline.time -side right

pack .statusline -side top -fill x -after $main_menubar

set time 0



# Code to update the statusline

proc statusline_update {name1 name2 op} {
    global bci_ready
    global bci_running
    global statusline_value
    global stdio_input

    if {$stdio_input} {
	set statusline_value "Input"
    } elseif {$bci_running} {
	set statusline_value "Running"
    } elseif {$bci_ready} {
	set statusline_value "Ready"
    } else {
	set statusline_value ""
    }
}

trace variable bci_ready w statusline_update
trace variable bci_running w statusline_update
trace variable stdio_input w statusline_update

statusline_update a b c

