#    The Language for Asynchronous Research and Development -- LARD
#    Copyright (C) 1996-1999 AMULET Group, Department of Computer Science
#        The University of Manchester, Oxford Road, Manchester, UK, M13 9PL
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#	$Id: winstdio.tcl,v 1.3 2000/03/25 13:42:12 bardslea Exp $
#
#
#   Winstdio module
#   Provide input/output in the stdio window
#   Superceeds stdio module
#   Also "save log"
#
#	11 Jun 1999, AMULET Group

li_require windows

global main_menubar
global main_notebook

$main_menubar.session.menu insert 0 command -label "Save log..." \
    -command stdio_save_log

# frame $stdio

set stdio [$main_notebook insert end stdio -text "Stdio"]
$main_notebook raise stdio

scrollbar $stdio.scr -command "$stdio.text yview"
pack $stdio.scr -side right -fill y
text $stdio.text -yscrollcommand "$stdio.scr set"
pack $stdio.text -side left -expand yes -fill both
pack $stdio -expand yes -fill both

set stdio_input 0


proc stdio_outline {line} {
	global stdio

    $stdio.text insert end $line
    $stdio.text yview -pickplace [$stdio.text index end]
}


proc stdio_inline {} {
    global bci_run_stop
    global stdio_input
    global stdio

    set bci_run_stop 1
    set stdio_input 1
    $stdio.text insert end "? "
    $stdio.text yview -pickplace [$stdio.text index end]
    bind $stdio.text <Return> "stdio_inline_callback; break"
}


proc stdio_inline_callback {} {
    global stdio_input
    global stdin_line
    global stdio

    set stdio_input 0
    bind $stdio.text <Return> ""
    set stdin_line [$stdio.text get {insert linestart + 2 chars} \
			{insert lineend}]
    $stdio.text insert insert "\n"
    bci_run
}


proc stdio_save_log {} {

    set stdio_save_log_filename [tk_getSaveFile -title "Save Log File"]
    if {$stdio_save_log_filename==""} {
	return
    }
    set f [open $stdio_save_log_filename w]
    puts $f [$stdio.text get 1.0 end]
    close $f
}

